// YtvGraphCtrlCtl.cpp : Implementation of the CYtvGraphCtrlCtrl ActiveX Control class.

#include "stdafx.h"
#include "YtvGraphCtrl.h"
#include "YtvGraphCtrlCtl.h"
#include "YtvGraphCtrlPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CYtvGraphCtrlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map
HBRUSH CYtvGraphCtrlCtrl::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	//HBRUSH hbr = COleControl::OnCtlColor(pDC, pWnd, nCtlColor);
	//     return hbr;
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	pDC->SetBkColor(m_clrChartBrush);
	//(HBRUSH)m_cbrChartBrush
	return NULL;
}
BEGIN_MESSAGE_MAP(CYtvGraphCtrlCtrl, COleControl)
	//{{AFX_MSG_MAP(CYtvGraphCtrlCtrl)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(OCM_COMMAND, OnOcmCommand)
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CYtvGraphCtrlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CYtvGraphCtrlCtrl)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "HMultiFactor", GetHMultiFactor, SetHMultiFactor, VT_R8)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "VMultiFactor", GetVMultiFactor, SetVMultiFactor, VT_R8)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ComplexGraph", GetComplexGraph, SetComplexGraph, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "NoiseLevel", GetNoiseLevel, SetNoiseLevel, VT_R8)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "GraphType", GetGraphType, SetGraphType, VT_I2)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "PalleteSize", GetPalleteSize, SetPalleteSize, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "BitsPerPixel", GetBitsPerPixel, SetBitsPerPixel, VT_I2)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "NumberOfBuffers", GetNumberOfBuffers, SetNumberOfBuffers, VT_I2)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "MaxWidth", GetMaxWidth, SetMaxWidth, VT_I2)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "MaxHeight", GetMaxHeight, SetMaxHeight, VT_R8)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "MinHeight", GetMinHeight, SetMinHeight, VT_R8)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "MaxGraphHeight", GetMaxGraphHeight, SetMaxGraphHeight, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ComputeMinMax", GetComputeMinMax, SetComputeMinMax, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "Stretch", GetStretch, SetStretch, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "DividingLineColor", GetDividingLineColor, SetDividingLineColor, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "DisplayBufferNumber", GetDisplayBufferNumber, SetDisplayBufferNumber, VT_I2)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "OddDisplay", GetOddDisplay, SetOddDisplay, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ReSizeHeight", GetReSizeHeight, SetReSizeHeight, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "OcuMethod", GetOcuMethod, SetOcuMethod, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "DrawScalePlank", GetDrawScalePlank, SetDrawScalePlank, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ScalePlankColor", GetScalePlankColor, SetScalePlankColor, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "CleanByBrush", GetCleanByBrush, SetCleanByBrush, VT_BOOL)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "HPosionLeft", GetHPosionLeft, SetHPosionLeft, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "HPositionRight", GetHPositionRight, SetHPositionRight, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "TopVerticalPosition", GetTopVerticalPosition, SetTopVerticalPosition, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "BackTextColor", GetBackTextColor, SetBackTextColor, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "BottomVerticalPosition", GetBottomVerticalPosition, SetBottomVerticalPosition, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ExternalDeviceContext", GetExternalDeviceContext, SetExternalDeviceContext, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ChartLineColor", GetChartLineColor, SetChartLineColor, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ChartBrushColor", GetChartBrushColor, SetChartBrushColor, VT_I4)
	DISP_PROPERTY_EX(CYtvGraphCtrlCtrl, "ChartLineSecondColor", GetChartLineSecondColor, SetChartLineSecondColor, VT_I4)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "FillBrush", FillBrush, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "SetInitMaxMinCoorY", SetInitMaxMinCoorY, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "DrawVerticalCursors", DrawVerticalCursors, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "CleanReDraw", CleanReDraw, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "PixelsFromUnitsLength", PixelsFromUnitsLength, VT_I4, VTS_R8)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "UnitsLengthFromPixels", UnitsLengthFromPixels, VT_R8, VTS_I4)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "PixelFromDataXCoor", PixelFromDataXCoor, VT_I4, VTS_I4)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "UnitLengthFromInpDataInputCoorX", UnitLengthFromInpDataInputCoorX, VT_R8, VTS_I4)
	DISP_FUNCTION(CYtvGraphCtrlCtrl, "InpXCoorFromPixels", InpXCoorFromPixels, VT_I4, VTS_I4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "Points", GetPoints, SetPoints, VT_I4, VTS_PI2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "PositionFloat", GetPositionFloat, SetPositionFloat, VT_I4, VTS_PR4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "PositionDouble", GetPositionDouble, SetPositionDouble, VT_I4, VTS_PR8)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "PositionInt", GetPositionInt, SetPositionInt, VT_I4, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "PalleteColors", GetPalleteColors, SetPalleteColors, VT_I4, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "FilterMaximum", GetFilterMaximum, SetFilterMaximum, VT_BOOL, VTS_PR8)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "LeftCursor", GetLeftCursor, SetLeftCursor, VT_BOOL, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "RightCursor", GetRightCursor, SetRightCursor, VT_BOOL, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "TopCursor", GetTopCursor, SetTopCursor, VT_BOOL, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "BottomCursor", GetBottomCursor, SetBottomCursor, VT_BOOL, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "Cursors", GetCursors, SetCursors, VT_I2, VTS_PI2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "CursorOnOff", GetCursorOnOff, SetCursorOnOff, VT_BOOL, VTS_I2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "CursorPosition", GetCursorPosition, SetCursorPosition, VT_I2, VTS_I2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "IPoints", GetIPoints, SetIPoints, VT_I4, VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "ScalePlank", GetScalePlank, SetScalePlank, VT_I2, VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "DrawLines", GetDrawLines, SetDrawLines, VT_I2, VTS_PI2 VTS_PI2 VTS_PI2)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "ScalePlankTextHoriz", GetScalePlankTextHoriz, SetScalePlankTextHoriz, VT_I4, VTS_PI4 VTS_PI4 VTS_PI4)
	DISP_PROPERTY_PARAM(CYtvGraphCtrlCtrl, "ExternalDeviceContextRectangle", GetExternalDeviceContextRectangle, SetExternalDeviceContextRectangle, VT_BOOL, VTS_PI2 VTS_PI2 VTS_PI2 VTS_PI2)
	DISP_STOCKPROP_READYSTATE()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CYtvGraphCtrlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CYtvGraphCtrlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CYtvGraphCtrlCtrl)
	EVENT_CUSTOM("CurrentBuffer", FireCurrentBuffer, VTS_I2)
	EVENT_CUSTOM("CursorCurrentValues", FireCursorCurrentValues, VTS_I2  VTS_I4  VTS_I4  VTS_R8)
	EVENT_STOCK_READYSTATECHANGE()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CYtvGraphCtrlCtrl, 1)
	PROPPAGEID(CYtvGraphCtrlPropPage::guid)
END_PROPPAGEIDS(CYtvGraphCtrlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CYtvGraphCtrlCtrl, "YTVGRAPHCTRL.YtvGraphCtrlCtrl.1",
	0x43c60f07, 0x64f7, 0x11e3, 0x8a, 0xc9, 0, 0x6, 0x29, 0xf7, 0x70, 0xac)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CYtvGraphCtrlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DYtvGraphCtrl =
		{ 0x43c60f05, 0x64f7, 0x11e3, { 0x8a, 0xc9, 0, 0x6, 0x29, 0xf7, 0x70, 0xac } };
const IID BASED_CODE IID_DYtvGraphCtrlEvents =
		{ 0x43c60f06, 0x64f7, 0x11e3, { 0x8a, 0xc9, 0, 0x6, 0x29, 0xf7, 0x70, 0xac } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwYtvGraphCtrlOleMisc =
	OLEMISC_SIMPLEFRAME |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_IGNOREACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CYtvGraphCtrlCtrl, IDS_YTVGRAPHCTRL, _dwYtvGraphCtrlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::CYtvGraphCtrlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CYtvGraphCtrlCtrl
CYtvGraphCtrlCtrl::CYtvGraphCtrlCtrl()
{
	m_bOcu=FALSE;
	m_pdcCurrentDisplayMemory=NULL;
	m_pbmCurrentOldBitmap=NULL;
	m_bMakeOutputToExternalDC=FALSE;
	m_hExternalDC=NULL;
	m_bComplexData=FALSE;
	m_nHPosionLeft=0;
	m_nHPosionRight=0;
	m_nVPosTop=0;
	m_nVPosBottom=0;
	m_bAutoResizeHeight=FALSE;
	m_bOddDisplay=TRUE;
	m_ptPoints=NULL;
	m_ptImPoints=NULL;
	m_nNumb=0;	
	m_uNumberPoints=0;
	m_bComputeMinMax=TRUE;
	m_bStretch=TRUE;
	m_rcMemBounds.left=m_rcMemBounds.top=0;
	m_ushBufNumber=0;
	m_ushPaintBufNumber=1;
	m_ushMaxNumberOfBuffers=2;
	m_ppdcDisplayMemory=NULL; 
    m_pbmBitmap=new CBitmap[m_ushMaxNumberOfBuffers];
	m_ppOldBitmap=new CBitmap*[m_ushMaxNumberOfBuffers];
	memset(m_ppOldBitmap,'\0',sizeof(CBitmap*)*m_ushMaxNumberOfBuffers);
	m_nPalleteSize=8;	
	m_pclrPallette=NULL;
	m_nBitsPerPixel=4;
	m_nMaxGraphHeight=259;
	m_nMemorySize=m_nMaxGraphHeight-3;
	m_nHalfMaxGraphHeight=m_nMaxGraphHeight/2;
	m_dMinHeight=0.0;
	m_dMaxHeight=0.0;
	m_ushMaxWidth=10;
	m_nSpecterMaxColumnNumber=m_ushMaxWidth;
	m_nSpecterColumnNumber=0;
	m_dNoiseLevel=0.0;
	m_nGraphType=0;
	m_bCleanByBrush=TRUE;
	m_dVMultifactor=0.0;
	m_dHMultifactor=0.0;
	m_dpDataBuf=NULL;
	m_dpMaxMinDataBuf=NULL;
	m_npMaxMinDataBuf=NULL;
	InitializeIIDs(&IID_DYtvGraphCtrl, &IID_DYtvGraphCtrlEvents);
	EnableSimpleFrame();
	m_lReadyState = READYSTATE_LOADING;
	m_clrChartBrush=RGB(0,0,0);
	m_cbrChartBrush.CreateSolidBrush(m_clrChartBrush);
	m_clrChartPen=RGB(255,255,0);
	m_clrChartPenIm=RGB(0,255,0);
	m_clrDividingLineColor=RGB(0,255,255);
	m_nPenChartWidth=1;
	m_nPenChartStyle=PS_SOLID;
	m_OldPen=NULL;
	m_OldBrush=NULL;
	m_OldBitmap=NULL;
	m_penChartPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartPen);
	m_penChartPenIm.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartPenIm);
    m_penChartBrushPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartBrush);
	m_rcMemBounds.bottom=m_nMaxGraphHeight-1;
    m_rcMemBounds.right=m_ushMaxWidth;
	m_dMaxFilterOff=30000.0;
	m_bMaxFilterOff=FALSE;
	m_bLeftCursor=FALSE;
	m_bRightCursor=FALSE;
	m_bTopCursor=FALSE;
	m_bBottomCursor=FALSE;
	m_nLeftCursor=0;
	m_nRightCursor=1;
	m_nTopCursor=1;
	m_nBottomCursor=0;
	m_bPrevLeftCursor=FALSE;
	m_bPrevRightCursor=FALSE;
	m_bPrevTopCursor=FALSE;
	m_bPrevBottomCursor=FALSE;
	m_ushNumberCursors=0;
	m_pnCursorPositions = NULL;
	m_pbCursorOn=NULL;
	m_pnPrevCursorPositions=NULL;
	////////////////////////////
    m_shVisibilityState=0;
	m_shBegXH=0;
	m_shBegYH=0;
	m_shLenXH=0;
	m_shLenYH=0;
	m_shHSmall=2;
	m_shHMedium=4;
	m_shHLong=6;
	m_shStepSmallH=1;
	m_shStepMediumH=5;
	m_shStepLongH=10;
	m_nFontScaleCountBeginH=0;
	m_nScaleTextStepHL=10;
	m_nScaleTextStepHM=5;
	m_nScaleTextStepHS=0;
	m_shDirectionUpDownCenterH=1;
	m_shAxisLineTypeH=1;
	m_clrScalePlankColor=RGB(0,255,255);
	m_clrScaleBackPlankColor=RGB(0,0,0);
	m_penScalePlankPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrScalePlankColor);
	m_ush3ListNumberPoints=m_ushListNumberPoints=0;
	m_pListCoor=NULL;
	/////////////////////////////
	InitMaxMin();
	// TODO: Call InternalSetReadyState when the readystate changes.

	// TODO: Initialize your control's instance data here.
}
BOOL CYtvGraphCtrlCtrl::CYtvGraphCtrlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_YTVGRAPHCTRL,
			IDB_YTVGRAPHCTRL,
			afxRegInsertable | afxRegApartmentThreading,
			_dwYtvGraphCtrlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::CYtvGraphCtrlCtrl - Constructor




/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::~CYtvGraphCtrlCtrl - Destructor

CYtvGraphCtrlCtrl::~CYtvGraphCtrlCtrl()
{
	// TODO: Cleanup your control's instance data here.
	double* pd;
	if(m_pdcCurrentDisplayMemory)
	{
        if(m_pbmCurrentOldBitmap)
            m_pdcCurrentDisplayMemory->SelectObject(m_pbmCurrentOldBitmap);
		delete m_pdcCurrentDisplayMemory;
    }
	if(m_dpMaxMinDataBuf)
		delete []m_dpMaxMinDataBuf;
	if(m_npMaxMinDataBuf)
        delete []m_npMaxMinDataBuf;	
	if(m_ppdcDisplayMemory)
	     delete []m_ppdcDisplayMemory;
    if(m_pbmBitmap)
		delete []m_pbmBitmap;
	if(m_pclrPallette)
		delete []m_pclrPallette;
	if(m_ppOldBitmap)
		delete []m_ppOldBitmap;
	if(m_ptPoints)
	    delete []m_ptPoints;
	if(m_ptImPoints)
		delete []m_ptImPoints;
	if(m_pnCursorPositions)
	    delete []m_pnCursorPositions;
	if(m_pbCursorOn)
		delete []m_pbCursorOn;
	if(m_pnPrevCursorPositions)
		delete []m_pnPrevCursorPositions;
	if(m_dpDataBuf)
	{
		pd=m_dpDataBuf;
		m_dpDataBuf=NULL;
		TRY
		{

		delete []pd;
		}
		CATCH_ALL(e)
        {


        }
		END_CATCH_ALL
    }
	if(m_pListCoor)
		delete []m_pListCoor;

    m_dpDataBuf=NULL;
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::OnDraw - Drawing function

void CYtvGraphCtrlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	DoSuperclassPaint(pdc, rcBounds);
	if (!IsOptimizedDraw())
	{
		// The container does not support optimized drawing.

		// TODO: if you selected any GDI objects into the device context *pdc,
		//		restore the previously-selected objects here.
		//		For more information, please see MFC technical note #nnn,
		//		"Optimizing an ActiveX Control".
	}
	
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::DoPropExchange - Persistence support

void CYtvGraphCtrlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CYtvGraphCtrlCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();

	// The control's output is not being clipped.
	// The control guarantees that it will not paint outside its
	// client rectangle.
	dwFlags &= ~clipPaintDC;

	// The control will not be redrawn when making the transition
	// between the active and inactivate state.
	dwFlags |= noFlickerActivate;

	// The control can receive mouse notifications when inactive.
	// TODO: if you write handlers for WM_SETCURSOR and WM_MOUSEMOVE,
	//		avoid using the m_hWnd member variable without first
	//		checking that its value is non-NULL.
	dwFlags |= pointerInactive;

	// The control can optimize its OnDraw method, by not restoring
	// the original GDI objects in the device context.
	dwFlags |= canOptimizeDraw;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::OnResetState - Reset control to default state

void CYtvGraphCtrlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::AboutBox - Display an "About" box to the user

void CYtvGraphCtrlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_YTVGRAPHCTRL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CYtvGraphCtrlCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.lpszClass = _T("STATIC");	
	return COleControl::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::IsSubclassedControl - This is a subclassed control

BOOL CYtvGraphCtrlCtrl::IsSubclassedControl()
{
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl::OnOcmCommand - Handle command messages

LRESULT CYtvGraphCtrlCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl message handlers
void CYtvGraphCtrlCtrl::SetMaxMinDataAtPosition(int i)
{   
	if(m_dpDataBuf==NULL || m_dpMaxMinDataBuf==NULL || m_npMaxMinDataBuf==NULL)
		return;
	if(i>=m_ushMaxWidth || i<0)
		return;
	int ii=i+i;
	if(m_dpDataBuf[i]>m_dpMaxMinDataBuf[ii])
	{
		m_dpMaxMinDataBuf[ii]=m_dpDataBuf[i];
		m_npMaxMinDataBuf[ii]=i;
    }
	ii++;
    if(m_dpDataBuf[i]<m_dpMaxMinDataBuf[ii])
	{
		m_dpMaxMinDataBuf[ii]=m_dpDataBuf[i];
        m_npMaxMinDataBuf[ii]=i;
    }


}
void CYtvGraphCtrlCtrl::InitMaxMin()
{
	int len=m_ushMaxWidth+m_ushMaxWidth;
	if(len<=0)
		return;
	if(!m_dpMaxMinDataBuf)
        m_dpMaxMinDataBuf=new double[len]; 
	if(!m_npMaxMinDataBuf)
        m_npMaxMinDataBuf=new int[len]; 
	for(int i=0; i<len;i+=2)
    {
       m_dpMaxMinDataBuf[i]=m_dMinHeight;
       m_dpMaxMinDataBuf[i+1]=m_dMaxHeight;
       m_npMaxMinDataBuf[i]=i;
       m_npMaxMinDataBuf[i+1]=i+1;
    }
}

long CYtvGraphCtrlCtrl::GetPoints(short FAR* PointsArray) 
{
	// TODO: Add your property handler here  
	for(int i = 0;  i<m_nMemorySize;i++)
	{
		PointsArray[i]=(short)m_dpDataBuf[i];	
    }
	return m_nMemorySize;
}
void CYtvGraphCtrlCtrl::InitYOCUCoor()
{
    for(int i = 0;  i<m_nMemorySize;i++)
	{
/*
'---------------------------------------------------------------
'     if( i = 0 + nLastSessionCount * nStoreLoopCount )
'       m_dpDataBuf(i) = 255
'     else if(( i = 50 + nLastSessionCount * nStoreLoopCount )
'       m_dpDataBuf(i) = 255
'     else if(( i = 112 + nLastSessionCount * nStoreLoopCount )
'       m_dpDataBuf(i) = 255
'     else if(( i = 750 + nLastSessionCount * nStoreLoopCount )
'        m_dpDataBuf(i) = 255
'     else
'        m_dpDataBuf(i) = 0
'     }//end if(
'---------------------------------------------------------------
*/
      if(m_dVMultifactor!=0.0)
	        m_ptPoints[i].y = (int)(m_nVPosBottom - m_dpDataBuf[i] * m_dVMultifactor);
      else
		  if(m_nVPosBottom)
	            m_ptPoints[i].y = m_nVPosBottom-(int)m_dpDataBuf[i]-20; 
		  else
			  m_ptPoints[i].y = (int)m_dpDataBuf[i]; 
      
	}
}	  
void CYtvGraphCtrlCtrl::InitYCoor()
{
	if(!m_dpDataBuf)
		return;
	double width,coefc,coefr,coefi,minv=m_dpDataBuf[0],maxv=m_dpDataBuf[0],minvi=m_dpDataBuf[1],maxvi=m_dpDataBuf[1];
    int i;
	if(m_bOcu)
	{
		InitYOCUCoor();
		return;
    }
	if(m_bComplexData)
    {
       for(i = 2;  i<m_nMemorySize-1;i+=2)
	   {
        if(m_dpDataBuf[i]>maxv)
			maxv=m_dpDataBuf[i];
		if(m_dpDataBuf[i+1]>maxvi)
			maxvi=m_dpDataBuf[i+1];
        if(m_dpDataBuf[i]<minv)
			minv=m_dpDataBuf[i];
        if(m_dpDataBuf[i+1]<minvi)
			minvi=m_dpDataBuf[i+1];		
	   }
       maxv-=minv;
	   maxvi-=minvi;	   	   
       if(maxv)
	   {  
          if(maxvi==0.0)
		  {
            width=maxv+minvi*0.5;			
          }
		  else
		      width=maxv+maxvi; 
		  coefr=maxv/width;
          for(i = 0;  i<m_nMemorySize;i+=2)
	            m_dpDataBuf[i] =coefr - ((m_dpDataBuf[i]-minv)/maxv*coefr);  
       }
	   else
       {
          if(maxvi==0.0)
			  width=minv+minvi*0.5;
		  else
		      width=minv+maxvi; 
		  if(width!=0.0)
		     coefr=minv/width;
		  else
			  coefr=0.0;
		  coefc=coefr*0.5;
          for(i = 0;  i<m_nMemorySize;i+=2)
                m_dpDataBuf[i]=coefc;
       } 
	   if(maxvi)
	   {
		  coefi=maxvi/width;
          for(i = 1;  i<m_nMemorySize;i+=2)
	            m_dpDataBuf[i] =(m_dpDataBuf[i]-minvi)/maxvi*coefi+coefr;  
       }
	   else
       {
          if(width!=0.0)
		       coefi=minvi/width*0.5+coefr;
		  else
			  coefi=0.0;
          for(i = 1;  i<m_nMemorySize;i+=2)
                m_dpDataBuf[i]=coefi;
       } 

    }
	else
	{
      maxv=minv=m_dpDataBuf[0];
      for(i = 1;  i<m_nMemorySize;i++)
	  {
        if(m_dpDataBuf[i]>maxv)
			maxv=m_dpDataBuf[i];
		if(m_dpDataBuf[i]<minv)
			minv=m_dpDataBuf[i];        
	  }     
	  if(maxv!=minv)
	  {   
	    maxv-=minv;
        for(i = 0;  i<m_nMemorySize;i++)
        {
			if(maxv!=0.0)
	           m_dpDataBuf[i] =1.0 - ((m_dpDataBuf[i]-minv)/maxv); 
			else
               m_dpDataBuf[i] =1.0;
        }
	  }
	  else if(maxv==0.0)
             m_dpDataBuf[i]=0.0;
	  else
         m_dpDataBuf[i]=0.5;
    }

}
void CYtvGraphCtrlCtrl::InitXOCUCoor()
{
	if(!m_ptPoints)
        m_ptPoints=new POINT[m_nMemorySize];
    for(int i = 0;  i<m_nMemorySize;i++)
    {
	if(m_dHMultifactor!=0.0)
		       m_ptPoints[i].x = int(i * m_dHMultifactor);
        else
		       m_ptPoints[i].x = int(i  * 1.2);
   }  
} 
void CYtvGraphCtrlCtrl::InitXCoor()
{
	RECT rt;
	int i;
	if(m_bOcu)
	{
		InitXOCUCoor();
        return;
    }
	GetClientRect(&rt);
	rt.right+=1;
	double coef,val=0.0,valb=(double)rt.right-m_nHPosionLeft-m_nHPosionRight;
    if(m_bComplexData)
    {
      if(m_uNumberPoints!=(unsigned)m_nNumb || m_ptImPoints==NULL)
	  {
        if(m_ptPoints)
            delete []m_ptPoints;
	    m_ptPoints=new POINT[m_nNumb];
		if(m_ptImPoints)
            delete []m_ptImPoints;
	    m_ptImPoints=new POINT[m_nNumb];
		m_uNumberPoints=m_nNumb;
	  }	 
      if(m_dHMultifactor!=0.0)
          coef=m_dHMultifactor;
	  else
      {
		  if(m_nNumb>1)
	          coef=valb/(double)(m_nNumb-1);
		  else
			  coef=0.0;
      }
      for(i = 0;  i<(int)m_uNumberPoints;i++)
	  {
		  m_ptPoints[i].x = int(val+0.5)+m_nHPosionLeft;
		  m_ptImPoints[i].x=m_ptPoints[i].x+1+m_nHPosionLeft;
		  val+=coef;
	  }	    
    }
	else
    {
      if(m_uNumberPoints!=(unsigned)m_nMemorySize || m_ptPoints==NULL)
	  {
        if(m_ptPoints)
            delete []m_ptPoints;
	    m_ptPoints=new POINT[m_nMemorySize];
		m_uNumberPoints=(unsigned)m_nMemorySize;
	  }		 
      if(m_dHMultifactor!=0.0)
          coef=m_dHMultifactor;
	  else
      {   
		  if(m_nMemorySize>1)
	         coef=valb/(double)(m_nMemorySize-1);
		  else
			  coef=0.0;
      }
      for(i = 0;  i<(int)m_uNumberPoints;i++)
	  {
		  m_ptPoints[i].x = int(val+0.5)+m_nHPosionLeft;
		  val+=coef;
	  }	
    }
	if(m_ptPoints[m_uNumberPoints-1].x>=rt.right)
         m_ptPoints[m_uNumberPoints-1].x=rt.right-1;
    

}
void CYtvGraphCtrlCtrl::SetPoints(short FAR* ArrayPos, long nNewValue) 
{
	// TODO: Add your property handler here 
	UpdateMemorySize(nNewValue); 
	for(int i=0; i<m_nMemorySize; i++)
    {
		m_dpDataBuf[i]=ArrayPos[i];
        SetMaxMinDataAtPosition(i);
    }
    if(m_bComplexData)
	      m_uNumberPoints=m_nMemorySize/2;
	else
          m_uNumberPoints=m_nMemorySize;
    InitXCoor();
	InitYCoor();
	//Invalidate(TRUE);
	SetModifiedFlag();
}

double CYtvGraphCtrlCtrl::GetHMultiFactor() 
{
	// TODO: Add your property handler here
	return m_dHMultifactor;
}

void CYtvGraphCtrlCtrl::SetHMultiFactor(double newValue) 
{
	// TODO: Add your property handler here
    m_dHMultifactor=newValue;
	InitXCoor();
	SetModifiedFlag();
}

double CYtvGraphCtrlCtrl::GetVMultiFactor() 
{
	// TODO: Add your property handler here
	return m_dVMultifactor;
}

void CYtvGraphCtrlCtrl::SetVMultiFactor(double newValue) 
{
	// TODO: Add your property handler here
    m_dVMultifactor=newValue;
	InitYCoor();
	SetModifiedFlag();
}


void CYtvGraphCtrlCtrl::FillYPoints()
{
	RECT rt;
	int i,j,maxi,mini,maxci,minci;
	GetClientRect(&rt);
	double par=m_dVMultifactor==0.0?(double)(rt.bottom-m_nVPosBottom-m_nVPosTop):m_dVMultifactor*(double)(rt.bottom-m_nVPosBottom-m_nVPosTop);
	if(m_bComplexData)
    {
      if(m_uNumberPoints!=(unsigned)m_nNumb || m_ptImPoints==NULL)
	  {
        if(m_ptPoints)
            delete []m_ptPoints;
	    m_ptPoints=new POINT[m_nNumb];
		if(m_ptImPoints)
            delete []m_ptImPoints;
	    m_ptImPoints=new POINT[m_nNumb];
		m_uNumberPoints=m_nNumb;
		InitXCoor();
	  }
	  if(!m_dpDataBuf)
		  return;
	  m_ptImPoints[0].y=maxci=minci=(int)(m_dpDataBuf[1]*par+0.5)+m_nVPosBottom; 
      m_ptPoints[0].y=maxi=mini=(int)(m_dpDataBuf[0]*par+0.5);
	  for(i=1;i<(int)m_uNumberPoints;i++)
	  {
            j=i+i;
			m_ptPoints[i].y=(int)(m_dpDataBuf[j]*par+0.5);
		    if(m_ptPoints[i].y>maxi)
				maxi=m_ptPoints[i].y;
			else if(m_ptPoints[i].y<mini)
				mini=m_ptPoints[i].y;
		    m_ptImPoints[i].y=(int)(m_dpDataBuf[j+1]*par+0.5)+m_nVPosBottom;
            if(m_ptImPoints[i].y>maxci)
				maxci=m_ptImPoints[i].y;
			else if(m_ptImPoints[i].y<minci)
				minci=m_ptImPoints[i].y;
	  } 
	  if(mini==maxi)
             for(i=0;i<(int)m_uNumberPoints;i++)
             	 m_ptPoints[i].y=rt.bottom-m_ptPoints[i].y-m_nVPosTop;
       if(minci==maxci)
             for(i=0;i<(int)m_uNumberPoints;i++)
             	 m_ptPoints[i].y=rt.bottom-m_ptPoints[i].y-m_nVPosTop+m_nVPosBottom;
             
	}
	else
    {
      if(m_uNumberPoints!=(unsigned)m_nMemorySize || m_ptPoints==NULL)
	  {
        if(m_ptPoints)
            delete []m_ptPoints;
	    m_ptPoints=new POINT[m_nMemorySize];
		m_uNumberPoints=(unsigned)m_nMemorySize;
		InitXCoor();
	  }	       
	  if(m_ptPoints && m_dpDataBuf)
      {
        m_ptPoints[0].y=maxi=mini=(int)(m_dpDataBuf[0]*par+0.5)+m_nVPosBottom; 
	    for(i=1;i<(int)m_uNumberPoints;i++)
		{
			m_ptPoints[i].y=(int)(m_dpDataBuf[i]*par+0.5)+m_nVPosBottom; 
		    if(m_ptPoints[i].y>maxi)
				maxi=m_ptPoints[i].y;
			else if(m_ptPoints[i].y<mini)
				mini=m_ptPoints[i].y;
		}
		if(mini==maxi)
             for(i=0;i<(int)m_uNumberPoints;i++)
                  m_ptPoints[i].y=rt.bottom-m_ptPoints[i].y-m_nVPosTop+m_nVPosBottom;

	  }	
    }
	
}
////////////ocu///////////////////////////////
void CYtvGraphCtrlCtrl::OnOCUPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if(m_nMemorySize>0)
	{
	  CPen *OldPen;
      RECT rcBounds;
	  GetClientRect(&rcBounds);
	  BOOL bRes;
	  dc.SetBkColor(m_clrChartBrush);
	  OldPen=dc.SelectObject(&m_penChartPen);
	  if(m_bCleanByBrush)
	  {
		  dc.FillRect(&rcBounds,&m_cbrChartBrush);         
      }
      bRes = dc.Polyline(m_ptPoints, m_uNumberPoints);
      if(bRes)
	  {
		  //TRACE("Polyline");
	      //UpdateWindow(); 
		  //Invalidate();
      }	 
	  dc.SelectObject(OldPen); 
	  DrawLines(dc.m_hDC,&m_penScalePlankPen);
	  DrawScalePlankHoriz(dc.m_hDC);
       
	}
	// Do not call COleControl::OnPaint() for painting messages
}

///////////ocu////////////////////////////////
void CYtvGraphCtrlCtrl::OnPaint() 
{
	
	if(m_bOcu)
    {
       OnOCUPaint();
       return;
    }
	CPaintDC dc(this); // device context for painting
	CRect rectUpdate;
	BOOL bRes;
    CRect rcBounds;
	GetClientRect(&rcBounds);
   
	// TODO: Add your message handler code here
	if(m_nMemorySize>0)
	{	  
	  int size=rcBounds.Width();
	  int height=rcBounds.Height();
	  dc.SetMapMode(MM_TEXT);
	  switch(m_nGraphType)
	  {
	   case 2:
		if(!m_pdcCurrentDisplayMemory)
			   break;
        m_OldBrush=m_pdcCurrentDisplayMemory->SelectObject(&m_cbrChartBrush);
		m_OldPen=m_pdcCurrentDisplayMemory->SelectObject(&m_penChartPen);
        m_uNumberPoints=size;
	    InitXCoor();
        FillYPoints();
	    if(m_bCleanByBrush)
		{
		  m_pdcCurrentDisplayMemory->FillRect(&rcBounds,&m_cbrChartBrush);  
		 
		}
	    bRes = m_pdcCurrentDisplayMemory->Polyline(m_ptPoints, m_uNumberPoints);
      if(m_bComplexData)
	  {
		  m_pdcCurrentDisplayMemory->SelectObject(&m_penChartPenIm);
		  bRes = m_pdcCurrentDisplayMemory->Polyline(m_ptImPoints, m_uNumberPoints);
      }
      if(bRes)
	  {
		  //TRACE("Polyline");
	      //UpdateWindow(); 
		  //Invalidate(TRUE);
      }  
      m_pdcCurrentDisplayMemory->SelectObject(m_OldPen);  
	  m_pdcCurrentDisplayMemory->SelectObject(m_OldBrush); 	
	  DrawScalePlankHoriz(m_pdcCurrentDisplayMemory->m_hDC);
	  DrawLines(m_pdcCurrentDisplayMemory->m_hDC,&m_penScalePlankPen);
	  dc.BitBlt(0,0,size,height,m_pdcCurrentDisplayMemory,0,0,SRCCOPY);
	  if(m_hExternalDC && m_bMakeOutputToExternalDC)
      {
		 StretchBlt(m_hExternalDC,m_rectExternalDevice.left,m_rectExternalDevice.top,m_rectExternalDevice.right-m_rectExternalDevice.left+1,m_rectExternalDevice.bottom-m_rectExternalDevice.top+1,m_pdcCurrentDisplayMemory->m_hDC,0,0,size,height,SRCCOPY);
      }	 
	   break;
	   /////////////////////////////////////////////
	   default:
		dc.FillRect(&rcBounds,&m_cbrChartBrush);
	   case 0:	
	    m_OldBrush=dc.SelectObject(&m_cbrChartBrush);
		m_OldPen=dc.SelectObject(&m_penChartPen);
        m_uNumberPoints=size;
	  InitXCoor();
      FillYPoints();
	  //dc.FillSolidRect(&rcBounds,m_clrChartBrush);
	  if(m_bCleanByBrush)
	  {
		  dc.FillRect(&rcBounds,&m_cbrChartBrush);  
		 
      }
	  //dc.SetPolyFillMode(WINDING);
      bRes = dc.Polyline(m_ptPoints, m_uNumberPoints);
      if(m_bComplexData)
	  {
		  dc.SelectObject(&m_penChartPenIm);
		  bRes = dc.Polyline(m_ptImPoints, m_uNumberPoints);
      }
      if(bRes)
	  {
		  //TRACE("Polyline");
	      //UpdateWindow(); 
		  //Invalidate(TRUE);
      }  
      dc.SelectObject(m_OldPen);  
	  dc.SelectObject(m_OldBrush); 	 
	  DrawScalePlankHoriz(dc.m_hDC);
	  DrawLines(dc.m_hDC,&m_penScalePlankPen);
		break;
       case 1://spectr
        //if(height!=m_nSpecterMaxColumnNumber)
        //    m_nSpecterMaxColumnNumber=height;
        //dc.GetClipBox(&rectUpdate);
        //m_ppdcDisplayMemory[m_ushPaintBufNumber]->SelectClipRgn(NULL);
        //m_ppdcDisplayMemory[m_ushPaintBufNumber]->IntersectClipRect(&rectUpdate);
        //m_OldBrush=m_ppdcDisplayMemory[m_ushPaintBufNumber]->SelectObject(&m_cbrChartBrush);
		//m_ppdcDisplayMemory[m_ushPaintBufNumber]->PatBlt(rectUpdate.left,rectUpdate.top,
		//	rectUpdate.Width(),rectUpdate.Height(),PATCOPY);
		//OnDraw(&m_ppdcDisplayMemory[m_ushBufNumber]);
        //m_ppdcDisplayMemory[m_ushPaintBufNumber]->SelectObject(&(m_pbmBitmap[m_ushPaintBufNumber])); 		
		if(m_bStretch)   
		   dc.StretchBlt(0,0,size,height,m_ppdcDisplayMemory[m_ushPaintBufNumber],0,0,m_ushMaxWidth,m_nMaxGraphHeight,SRCCOPY);
		else
           dc.BitBlt(0,0,size,height,m_ppdcDisplayMemory[m_ushPaintBufNumber],0,0,SRCCOPY);
		 //m_ppdcDisplayMemory[m_ushPaintBufNumber]->SelectObject(m_OldBrush); 		
		//m_ppdcDisplayMemory[m_ushPaintBufNumber]->SelectObject(m_ppOldBitmap[m_ushPaintBufNumber]); 		
		break;
	  }//end switch
      
	}//end if(mem>0)
	else
		dc.FillRect(&rcBounds,&m_cbrChartBrush);
	// Do not call COleControl::OnPaint() for painting messages
}

void CYtvGraphCtrlCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if(IsWindow(m_hWnd))
	{
		switch(m_nGraphType)
		{
        case 2:
			SetCurrentBitmap();
            Invalidate(FALSE); 
			break;
		case 1:
			Invalidate(FALSE); 
			break;
        default:
		case 0:
			RECT rcBounds;
            GetClientRect(&rcBounds);
			GetDC()->FillRect(&rcBounds,&m_cbrChartBrush);
			//Invalidate(TRUE);
        }
		SetTopCursor((long*)&m_nTopCursor,m_bTopCursor);
		SetBottomCursor((long*)&m_nBottomCursor,m_bBottomCursor);
		SetLeftCursor((long*)&m_nLeftCursor,m_bLeftCursor);
		SetRightCursor((long*)&m_nRightCursor,m_bRightCursor);
    }
}



long CYtvGraphCtrlCtrl::GetPositionFloat(float FAR* SetPos) 
{
	// TODO: Add your property handler here

	return 0;
}
void CYtvGraphCtrlCtrl::InitSpecter()
{
	int ColumnShift=0,j,jj,i,nSegment;
	double dtemp;
	//m_ushPaintBufNumber=m_ushBufNumber=1;
	if(m_nSpecterColumnNumber>=m_nSpecterMaxColumnNumber)
    {
		m_nSpecterColumnNumber=0;
		//InitMemDC();
		//m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(m_ppOldBitmap[m_ushBufNumber]); 	
		if(m_bOddDisplay)
		    m_ushPaintBufNumber=m_ushBufNumber++;
		else
		    m_ushPaintBufNumber=m_ushBufNumber;
	    if(m_ushMaxNumberOfBuffers<=m_ushBufNumber)
              m_ushBufNumber=0;
		FireCurrentBuffer(m_ushPaintBufNumber);		
	    //m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(&(m_pbmBitmap[m_ushBufNumber]));
		FillBufferBrush(m_ushBufNumber); 	
		Invalidate(FALSE);
    }
	//else
	//	m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(&(m_pbmBitmap[m_ushBufNumber]));
	short palind,indpixel;
	m_OldBrush=m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(&m_cbrChartBrush);
   	if(m_bAutoResizeHeight)
	  if((DWORD)m_nMemorySize>m_nMaxGraphHeight-3)
	  {
		m_nMaxGraphHeight=m_nMemorySize+3;
		m_nHalfMaxGraphHeight=m_nMaxGraphHeight/2;
		m_rcMemBounds.bottom=m_nMaxGraphHeight-1;
        SetNumberOfBuffers(m_ushMaxNumberOfBuffers);		
	  }
	if(m_bComputeMinMax)
	{
	  for(int i=0;i<m_nMemorySize;i++)
	  {
		if(m_dMinHeight>m_dpDataBuf[i])
		   m_dMinHeight=m_dpDataBuf[i];
        if(m_dMaxHeight<m_dpDataBuf[i])
		   m_dMaxHeight=m_dpDataBuf[i];
	  }
    }
    //DoSuperclassPaint(m_ppdcDisplayMemory[m_ushBufNumber], m_rcMemBounds);
	m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber, 0,m_clrChartBrush);
	m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber, m_nMaxGraphHeight-1,m_clrChartBrush);

	if(m_bComplexData)
    {
	 m_nNumb=m_nMemorySize/2;
	 nSegment=m_nHalfMaxGraphHeight;
	 for(i=0,j=0;i<m_nMemorySize-1;i+=2,j++)
     {
       m_dpDataBuf[i]-=m_dMinHeight;
	   m_dMaxHeight-=m_dMinHeight;
       m_dpDataBuf[i+1]-=m_dMinHeight;
       dtemp=m_dMaxHeight-m_dMinHeight;
	   if(dtemp!=0.0)
       {
		   m_dpDataBuf[i]/=dtemp;	  
           m_dpDataBuf[i+1]/=dtemp;
       }
	   palind=(short)((m_dpDataBuf[i]*m_nPalleteSize))-1;
	   if(palind>=m_nPalleteSize)
           palind=m_nPalleteSize-1;
       if(palind<0)
           palind=0;
	   if(m_bAutoResizeHeight)
	      indpixel=(short)m_nNumb-(short)j;
	   else
	   {
          jj=j%nSegment+1; 
		  indpixel=(int)(m_nHalfMaxGraphHeight-jj);
          ColumnShift=j/nSegment; 
       }
       if(indpixel>(short)m_nNumb)
          indpixel=(short)m_nNumb;
       if(indpixel<0)
          indpixel=0;
	   m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber+ColumnShift, indpixel, m_pclrPallette[palind]);
	   palind=(short)((m_dpDataBuf[i+1]*m_nPalleteSize))-1;
	   if(palind>=m_nPalleteSize)
           palind=m_nPalleteSize-1;
	   if(palind<0)
           palind=0;
	   if(m_bAutoResizeHeight)
            indpixel=m_nMemorySize-indpixel+2; 
	   else
            indpixel=(int)(jj+m_nHalfMaxGraphHeight);
	   if(indpixel>(short)(m_nMaxGraphHeight-2))
          indpixel=(short)(m_nMaxGraphHeight-2);
	   m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber+ColumnShift, indpixel, m_pclrPallette[palind]);
	 }    
	 m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber, m_nHalfMaxGraphHeight,m_clrDividingLineColor);
     m_nSpecterColumnNumber+=ColumnShift; 
	}
	else
	{
	 for(int i=0;i<m_nMemorySize;i++)
     {
       dtemp=m_dMaxHeight-m_dMinHeight;
       m_dpDataBuf[i]-=m_dMinHeight;
	   if(dtemp!=0.0)
           m_dpDataBuf[i]/=dtemp;
	   palind=(short)((m_dpDataBuf[i]*(double)m_nPalleteSize+0.5))-1;
	   if(palind>=m_nPalleteSize)
           palind=m_nPalleteSize-1;
	   if(palind<0)
           palind=0;
	   if(m_bAutoResizeHeight)
	      indpixel=(int)(m_nMaxGraphHeight-i-2);
	   else
	   {
		  indpixel=(int)(m_nMaxGraphHeight-i%m_nMaxGraphHeight+1);
          ColumnShift=i/m_nMaxGraphHeight; 
       }
	   m_ppdcDisplayMemory[m_ushBufNumber]->SetPixelV(m_nSpecterColumnNumber+ColumnShift, indpixel, m_pclrPallette[palind]);
	 }
	 m_nSpecterColumnNumber+=ColumnShift; 
    }
	m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(&m_OldBrush);
	//m_ppdcDisplayMemory[m_ushBufNumber]->SelectObject(m_ppOldBitmap[m_ushBufNumber]); 	
	m_nSpecterColumnNumber++;
}
void CYtvGraphCtrlCtrl::SetPositionFloat(float FAR* ArrayPos, long nNewValue) 
{
	// TODO: Add your property handler here
	RECT rcBounds;
	UpdateMemorySize(nNewValue); 
    m_nNumb=m_nMemorySize/2;
	for(int i=0; i<m_nMemorySize; i++)
	{
		if(m_dNoiseLevel > ((ArrayPos[i]>0)?ArrayPos[i]:-ArrayPos[i]))
              m_dpDataBuf[i]=0.0;
		else
    	      m_dpDataBuf[i]=ArrayPos[i];
		if(m_bMaxFilterOff)
        {
          if(m_dMaxFilterOff < ((ArrayPos[i]>0)?ArrayPos[i]:-ArrayPos[i]))
               m_dpDataBuf[i]=m_dMaxFilterOff;
		  else
			   m_dpDataBuf[i]=ArrayPos[i];
        }
		SetMaxMinDataAtPosition(i);
    }    
	m_uNumberPoints=m_nMemorySize;
	switch(m_nGraphType)
    {
	default:
	case 0:
		InitXCoor();
	    InitYCoor();		
        GetClientRect(&rcBounds);
		GetDC()->FillRect(&rcBounds,&m_cbrChartBrush);
		//Invalidate(TRUE);
		break;
    case 1://spectr
        InitSpecter();
		break;
    case 2:
		InitXCoor();
	    InitYCoor();	
		break;
    }
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetPositionDouble(double FAR* ArrayPos) 
{
	// TODO: Add your property handler here

	return m_nMemorySize;
}

void CYtvGraphCtrlCtrl::SetPositionDouble(double FAR* ArrayPos, long nNewValue) 
{
	// TODO: Add your property handler here
	RECT rcBounds;
	UpdateMemorySize(nNewValue); 
	m_nNumb=m_nMemorySize/2;
	for(int i=0; i<m_nMemorySize; i++)
	{
		if(m_dNoiseLevel > ((ArrayPos[i]>0)?ArrayPos[i]:-ArrayPos[i]))
              m_dpDataBuf[i]=0.0;
		else
    	      m_dpDataBuf[i]=ArrayPos[i];
		if(m_bMaxFilterOff)
        {
          if(m_dMaxFilterOff < ((ArrayPos[i]>0)?ArrayPos[i]:-ArrayPos[i]))
               m_dpDataBuf[i]=m_dMaxFilterOff;
		  else
			   m_dpDataBuf[i]=ArrayPos[i];
        }
		SetMaxMinDataAtPosition(i);
    }
    if(m_bComplexData)
         m_uNumberPoints=m_nNumb;
	else
	     m_uNumberPoints=m_nMemorySize;
	switch(m_nGraphType)
    {
	default:
	case 0:
		m_uNumberPoints=m_nMemorySize;
		InitXCoor();
	    InitYCoor();
		GetClientRect(&rcBounds);
		//GetDC()->FillRect(&rcBounds,&m_cbrChartBrush);
		//InvalidateRect(&rcBounds,TRUE);
		break;
    case 1://spectr
		if(m_bAutoResizeHeight)
		  if(m_nMemorySize!=(int)(m_nMaxGraphHeight-3))
             SetMaxGraphHeight(m_nMemorySize+3);
        InitSpecter();	
		break;
    case 2:
        m_uNumberPoints=m_nMemorySize;
		InitXCoor();
	    InitYCoor();
		break;
    }
   
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetComplexGraph() 
{
	// TODO: Add your property handler here

	return m_bComplexData;
}

void CYtvGraphCtrlCtrl::SetComplexGraph(BOOL bNewValue) 
{
	// TODO: Add your property handler here
	if(m_bComplexData!=bNewValue)
    {
        if(m_ptPoints)
            delete []m_ptPoints;	    
		if(m_ptImPoints)
            delete []m_ptImPoints;
		if(m_nNumb)
		{
		  if(bNewValue)
		  {
			m_ptPoints=new POINT[m_nNumb];
	        m_ptImPoints=new POINT[m_nNumb];
		  }
		  else
		  {
            m_ptPoints=new POINT[m_nMemorySize];
	        m_ptImPoints=new POINT[m_nMemorySize];
		  }
        }
		else
        {
            m_ptPoints=NULL;
	        m_ptImPoints=NULL;
        }
		m_bComplexData=bNewValue;
    }
    
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetPositionInt(long FAR* ArrayPos) 
{
	// TODO: Add your property handler here

	return 0;
}
void CYtvGraphCtrlCtrl::UpdateMemorySize(int nNewValue)
{
    if(m_dpDataBuf!=NULL)
	{
		if(nNewValue>m_nMemorySize)
        {
			delete []m_dpDataBuf;
			m_dpDataBuf=NULL;
            m_dpDataBuf=new double[nNewValue+1];          
			InitMaxMin();
        }
    }
	else
    {
		m_dpDataBuf=new double[nNewValue+1];	
		InitMaxMin();
    }
    m_nMemorySize=nNewValue;
	
}
void CYtvGraphCtrlCtrl::SetPositionInt(long FAR* ArrayPos, long nNewValue) 
{
	// TODO: Add your property handler here
	RECT rcBounds;
    UpdateMemorySize(nNewValue); 
	for(int i=0; i<m_nMemorySize; i++)
    {
		m_dpDataBuf[i]=ArrayPos[i];
		SetMaxMinDataAtPosition(i);
    }
	m_uNumberPoints=m_nMemorySize;
    InitXCoor();
	InitYCoor();
	GetClientRect(&rcBounds);
	GetDC()->FillRect(&rcBounds,&m_cbrChartBrush);
	//Invalidate(TRUE);
	SetModifiedFlag();
}

double CYtvGraphCtrlCtrl::GetNoiseLevel() 
{
	// TODO: Add your property handler here

	return m_dNoiseLevel;
}

void CYtvGraphCtrlCtrl::SetNoiseLevel(double newValue) 
{
	// TODO: Add your property handler here
    m_dNoiseLevel=newValue;
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetGraphType() 
{
	// TODO: Add your property handler here

	return m_nGraphType;
}

void CYtvGraphCtrlCtrl::SetGraphType(short nNewValue) 
{
	// TODO: Add your property handler here
	RECT rcBounds;
    m_nGraphType=nNewValue;
	switch(m_nGraphType)
	{
    case 2:
        SetCurrentBitmap();
		break;
	case 1:
		   FireCurrentBuffer(m_ushPaintBufNumber);
		   Invalidate(FALSE);
		   break;
	default:
    case 0:		
            GetClientRect(&rcBounds);
           	GetDC()->FillRect(&rcBounds,&m_cbrChartBrush);
		    break;
    }
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetPalleteSize() 
{
	// TODO: Add your property handler here

	return m_nPalleteSize;
}

void CYtvGraphCtrlCtrl::SetPalleteSize(long nNewValue) 
{
	// TODO: Add your property handler here
	CClientDC dc(this);
	int i;
    m_nPalleteSize=nNewValue;
	if(m_pclrPallette)
		delete []m_pclrPallette;
	if(m_nPalleteSize)
        m_pclrPallette=new COLORREF[m_nPalleteSize];
	else
	{
		m_pclrPallette=NULL;
		return;
    }
/*	PALETTEENTRY* ppent=new PALETTEENTRY[m_nPalleteSize];

	UINT res=GetSystemPaletteEntries(
  dc.m_hDC,              // handle of device context
  0,     // index of first entry to be retrieved
  m_nPalleteSize,        // number of entries to be retrieved
  ppent   // array receiving system-palette entries
);

	if(!res)
    {*/
        int step=255/(m_nPalleteSize-1),ind=0; 
        for(i=0; i<m_nPalleteSize;i++)
		{			
			if(ind<0)
				ind=0;
			if(ind>255)
				ind=255;
			m_pclrPallette[i]=RGB(ind,ind,ind);
			ind+=step;
        }
 /*   }
    else
		for(i=0; i<m_nPalleteSize;i++)
           m_pclrPallette[i]=RGB(ppent->peRed,ppent->peGreen,ppent->peBlue);
	delete []ppent;*/
	SetModifiedFlag();
}

double CYtvGraphCtrlCtrl::GetMinHeight() 
{
	// TODO: Add your property handler here

	return m_dMinHeight;
}

void CYtvGraphCtrlCtrl::SetMinHeight(double newValue) 
{
	// TODO: Add your property handler here
    m_dMinHeight=newValue;
	InitMaxMin();
	SetModifiedFlag();
}

double CYtvGraphCtrlCtrl::GetMaxHeight() 
{
	// TODO: Add your property handler here

	return m_dMaxHeight;
}

void CYtvGraphCtrlCtrl::SetMaxHeight(double newValue) 
{
	// TODO: Add your property handler here
    m_dMaxHeight=newValue;
	InitMaxMin();
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetBitsPerPixel() 
{
	// TODO: Add your property handler here
	return m_nBitsPerPixel;
}

void CYtvGraphCtrlCtrl::SetBitsPerPixel(short nNewValue) 
{
	// TODO: Add your property handler here
    m_nBitsPerPixel=(int)nNewValue;
	SetModifiedFlag();
}

int CYtvGraphCtrlCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//m_dibm.AttachMemory();
	//biSize
	CRect rt;
	GetClientRect(&rt);
	if(rt.Width()<m_ushMaxWidth)
       m_ushMaxWidth=rt.Width();
    SetMaxWidth(m_ushMaxWidth);
	SetPalleteSize(m_nPalleteSize);
	SetBitmaps();
	CClientDC dc(this);
	m_nOldStretchMode=dc.SetStretchBltMode(COLORONCOLOR);
	m_hFirstBrushHandle=(HBRUSH)GetClassLong(m_hWnd,GCL_HBRBACKGROUND);
	//SetClassLong(m_hWnd,GCL_HBRBACKGROUND,(long)(HBRUSH)m_cbrChartBrush);
	FillBrush(); 
	m_OldBrush=dc.SelectObject(&m_cbrChartBrush);
	dc.FillRect(&rt,&m_cbrChartBrush);
	dc.SelectObject(m_OldBrush);
	m_font.CreateFont(150, 0, 0, 0, 400, FALSE, FALSE,
               0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
               CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
               DEFAULT_PITCH | FF_SWISS, "Arial");  
	//Invalidate(TRUE);
	//FireCurrentBuffer(m_ushPaintBufNumber);
	return 0;
}
void CYtvGraphCtrlCtrl::SetBitmaps()
{
    CClientDC dc(this);
	for(int i=0; i<m_ushMaxNumberOfBuffers; i++)
    {
		if(m_ppdcDisplayMemory[i]->GetSafeHdc()==NULL)
		{
           m_ppdcDisplayMemory[i]->CreateCompatibleDC(&dc);
		   m_pbmBitmap[i].CreateCompatibleBitmap(&dc,m_ushMaxWidth,m_nMaxGraphHeight);
           m_ppdcDisplayMemory[i]->SetMapMode(MM_TEXT);
		   m_ppOldBitmap[i]=m_ppdcDisplayMemory[i]->SelectObject(&m_pbmBitmap[i]);
		}
    }
}
void CYtvGraphCtrlCtrl::SetCurrentBitmap()
{//method 2
    CClientDC dc(this);	
	RECT rt;
	GetClientRect(&rt);
	if(m_pdcCurrentDisplayMemory)
	{
		if(m_pbmCurrentOldBitmap)
            m_pdcCurrentDisplayMemory->SelectObject(m_pbmCurrentOldBitmap);
	    delete m_pdcCurrentDisplayMemory;
        m_pdcCurrentDisplayMemory=NULL;
	}
	if(!m_pdcCurrentDisplayMemory)
	   m_pdcCurrentDisplayMemory=new CDC;
	if(m_pdcCurrentDisplayMemory->GetSafeHdc()==NULL)
	{
           m_pdcCurrentDisplayMemory->CreateCompatibleDC(&dc);
		   m_bmCurrentBitmap.CreateCompatibleBitmap(&dc,rt.right+1,rt.bottom+1);
           m_pdcCurrentDisplayMemory->SetMapMode(MM_TEXT);
		   m_pbmCurrentOldBitmap=m_pdcCurrentDisplayMemory->SelectObject(&m_bmCurrentBitmap);
		   m_pdcCurrentDisplayMemory->FillRect(&rt,&m_cbrChartBrush);
	}
   
}
short CYtvGraphCtrlCtrl::GetNumberOfBuffers() 
{
	// TODO: Add your property handler here

	return m_ushMaxNumberOfBuffers;
}
void CYtvGraphCtrlCtrl::InitMemDC()
{
	int i;
   	CClientDC dc(this);
	RECT rt;
	rt.bottom=m_nMaxGraphHeight-1;
	rt.right=m_ushMaxWidth-1;
	rt.left=0;
	rt.top=0;
	for(i=0; i<m_ushMaxNumberOfBuffers; i++)
    {
		if(m_ppdcDisplayMemory)
		{
           if(m_ppOldBitmap[i])
              m_ppdcDisplayMemory[i]->SelectObject(m_ppOldBitmap[i]);
		   delete m_ppdcDisplayMemory[i];
        }
		m_ppdcDisplayMemory[i]=new CDC;
		if(m_ppdcDisplayMemory[i]->GetSafeHdc()==NULL)
		{
           m_ppdcDisplayMemory[i]->CreateCompatibleDC(&dc);
		   m_ppdcDisplayMemory[i]->SetMapMode(MM_TEXT);
		   m_ppOldBitmap[i]=m_ppdcDisplayMemory[i]->SelectObject(&m_pbmBitmap[i]);
           m_ppdcDisplayMemory[i]->FillSolidRect(&rt,m_clrChartBrush);
		}
    }
}
void CYtvGraphCtrlCtrl::SetNumberOfBuffers(short nNewValue) 
{
	// TODO: Add your property handler here	
    int i;
	if(m_ppdcDisplayMemory)
	{
        for(i=0; i<m_ushMaxNumberOfBuffers;i++)
        {
           if(m_ppOldBitmap[i])
              m_ppdcDisplayMemory[i]->SelectObject(m_ppOldBitmap[i]);
		   delete m_ppdcDisplayMemory[i];
        }
		delete []m_ppdcDisplayMemory;
    }
	if(m_pbmBitmap)
		delete []m_pbmBitmap;
	if(m_ppOldBitmap)
		delete []m_ppOldBitmap;
	else
        m_ppOldBitmap=NULL;
	m_ushMaxNumberOfBuffers=nNewValue;
	if(m_ushMaxNumberOfBuffers)
    {
		m_ppdcDisplayMemory= new CDC*[m_ushMaxNumberOfBuffers];
		for(i=0;i<m_ushMaxNumberOfBuffers;i++)
              m_ppdcDisplayMemory[i]= new CDC;
		m_pbmBitmap=new CBitmap[m_ushMaxNumberOfBuffers];
		m_ppOldBitmap=new CBitmap*[m_ushMaxNumberOfBuffers];
		memset(m_ppOldBitmap,'\0',sizeof(CBitmap*)*m_ushMaxNumberOfBuffers);
		SetBitmaps();
    }
	else
    {
		m_ppdcDisplayMemory=NULL;
		m_pbmBitmap=NULL;
        m_ppOldBitmap=NULL;
    }
	FillBrush(); 
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetMaxWidth() 
{
	// TODO: Add your property handler here

	return m_ushMaxWidth;
}

void CYtvGraphCtrlCtrl::SetMaxWidth(short nNewValue) 
{
	// TODO: Add your property handler here
    m_nSpecterMaxColumnNumber=m_ushMaxWidth=nNewValue;
    m_rcMemBounds.right=m_ushMaxWidth;
	SetNumberOfBuffers(m_ushMaxNumberOfBuffers); 
	if(m_npMaxMinDataBuf)
    {
		delete []m_npMaxMinDataBuf;
        m_npMaxMinDataBuf=NULL;
    }
    if(m_dpMaxMinDataBuf)
	{
		delete []m_dpMaxMinDataBuf;
        m_dpMaxMinDataBuf=NULL; 
    }
	InitMaxMin();
	Invalidate(FALSE);
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetPalleteColors(long FAR* PalleteRGBColors) 
{
	// TODO: Add your property handler here
	if(PalleteRGBColors)
           PalleteRGBColors=(long*)m_pclrPallette;
	return m_nPalleteSize;
}

void CYtvGraphCtrlCtrl::SetPalleteColors(long FAR* PalleteRGBColors, long nNewValue) 
{
	// TODO: Add your property handler here
     m_nPalleteSize=nNewValue;
	if(m_pclrPallette)
		delete []m_pclrPallette;
	if(m_nPalleteSize)
        m_pclrPallette=new COLORREF[m_nPalleteSize];
	else
	{
		m_pclrPallette=NULL;
		return;
    }
    if(!PalleteRGBColors)
		return;
	for(int i=0;i<m_nPalleteSize;i++)
        m_pclrPallette[i]=PalleteRGBColors[i];
	SetModifiedFlag();
}

void CYtvGraphCtrlCtrl::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	SetNumberOfBuffers(0); 
	if(m_dpDataBuf)
		delete []m_dpDataBuf;
    m_dpDataBuf=NULL;
	CWnd::OnClose();
}
long CYtvGraphCtrlCtrl::GetMaxGraphHeight() 
{
	// TODO: Add your property handler here
	return m_nMaxGraphHeight;
}

void CYtvGraphCtrlCtrl::SetMaxGraphHeight(long nNewValue) 
{
	// TODO: Add your property handler here
    m_nMaxGraphHeight=nNewValue;
	m_nHalfMaxGraphHeight=m_nMaxGraphHeight/2;
	m_rcMemBounds.bottom=m_nMaxGraphHeight-1;
    SetNumberOfBuffers(m_ushMaxNumberOfBuffers); 
	Invalidate(FALSE);
    SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetComputeMinMax() 
{
	// TODO: Add your property handler here

	return m_bComputeMinMax;
}

void CYtvGraphCtrlCtrl::SetComputeMinMax(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bComputeMinMax=bNewValue;
	SetModifiedFlag();
}
void CYtvGraphCtrlCtrl::FillBufferBrush(unsigned short i)
{
    m_ppdcDisplayMemory[i]->FillRect(&m_rcMemBounds,&m_cbrChartBrush);
    m_bPrevLeftCursor=FALSE;
	m_bPrevRightCursor=FALSE;
	m_bPrevTopCursor=FALSE;
	m_bPrevBottomCursor=FALSE;
/*	if(m_bLeftCursor)
         DrawLineInvert(m_nLeftCursor,0, m_nLeftCursor,m_nMaxGraphHeight-1,i);
	if(m_bTopCursor)
		 DrawLineInvert(0,m_nMaxGraphHeight-m_nTopCursor-1,m_ushMaxWidth-1,m_nMaxGraphHeight-m_nTopCursor-1,i);
	if(m_bRightCursor)
		 DrawLineInvert(m_nRightCursor,0,m_nRightCursor,m_nMaxGraphHeight-1,i);
	if(m_bBottomCursor)
		 DrawLineInvert(0,m_nMaxGraphHeight-m_nBottomCursor-1,m_ushMaxWidth-1,m_nMaxGraphHeight-m_nBottomCursor-1,i);
*/	
}
void CYtvGraphCtrlCtrl::FillBrush() 
{
	// TODO: Add your dispatch handler code here	
    for(unsigned short i=0; i<m_ushMaxNumberOfBuffers;i++)
    	FillBufferBrush(i);
    
}

BOOL CYtvGraphCtrlCtrl::GetStretch() 
{
	// TODO: Add your property handler here

	return m_bStretch;
}

void CYtvGraphCtrlCtrl::SetStretch(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bStretch=bNewValue;
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

long CYtvGraphCtrlCtrl::GetDividingLineColor() 
{
	// TODO: Add your property handler here

	return m_clrDividingLineColor;
}

void CYtvGraphCtrlCtrl::SetDividingLineColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrDividingLineColor=(COLORREF)nNewValue;
	SetModifiedFlag();
}
short CYtvGraphCtrlCtrl::GetDisplayBufferNumber() 
{
	// TODO: Add your property handler here

	return m_ushPaintBufNumber;
}

void CYtvGraphCtrlCtrl::SetDisplayBufferNumber(short nNewValue) 
{
	// TODO: Add your property handler here
    m_ushPaintBufNumber=(unsigned short)nNewValue;
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetOddDisplay() 
{
	// TODO: Add your property handler here

	return m_bOddDisplay;
}

void CYtvGraphCtrlCtrl::SetOddDisplay(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bOddDisplay=bNewValue;
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetFilterMaximum(double FAR* MaximumValue) 
{
	// TODO: Add your property handler here
    if(MaximumValue)
	    *MaximumValue=m_dMaxFilterOff;
	return m_bMaxFilterOff;
}

void CYtvGraphCtrlCtrl::SetFilterMaximum(double FAR* MaximumValue, BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bMaxFilterOff=bNewValue;
	if(MaximumValue)
	    m_dMaxFilterOff=*MaximumValue;
	SetModifiedFlag();
}
void CYtvGraphCtrlCtrl::DrawLineInvert(int xfrom, int yfrom, int xto, int yto, int BufferNumber)
{
   int i,minp, maxp; 
   COLORREF clr;
   if(xfrom==xto)
   {
     if(yfrom>yto)
     {
        minp=yto;
		maxp=yfrom;
     }
	 else
     {
        minp=yfrom;
		maxp=yto;
     } 
     for(i=minp; i<=maxp;i++)
     {
		 clr=m_ppdcDisplayMemory[BufferNumber]->GetPixel(xto,i);
		 clr^=0x00FFFFFF;
         m_ppdcDisplayMemory[BufferNumber]->SetPixel(xto,i,clr);
     }
   }
   else if(yto==yfrom)
   {
     if(xfrom>xto)
     {
        minp=xto;
		maxp=xfrom;
     }
	 else
     {
        minp=xfrom;
		maxp=xto;
     } 
     for(i=minp; i<=maxp;i++)
     {
		 clr=m_ppdcDisplayMemory[BufferNumber]->GetPixel(i,yto);
		 clr^=0x00FFFFFF;
         m_ppdcDisplayMemory[BufferNumber]->SetPixel(i,yto,clr);
     }
   }

}
BOOL CYtvGraphCtrlCtrl::GetLeftCursor(long FAR* pPosition) 
{
	// TODO: Add your property handler here
    if(pPosition)
        *pPosition=m_nLeftCursor;
	return m_bLeftCursor;
}

void CYtvGraphCtrlCtrl::SetLeftCursor(long FAR* pPosition, BOOL bNewValue) 
{
	// TODO: Add your property handler here
	if(m_bPrevLeftCursor)
    {
       DrawLineInvert(m_nLeftCursor, 0,m_nLeftCursor,m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   m_bPrevLeftCursor=FALSE;	   
    }
	if(pPosition)
        m_nLeftCursor=*pPosition;
    m_nLeftCursor%=m_ushMaxWidth; 
    m_bLeftCursor=bNewValue;
    if(m_bLeftCursor)
    {
       DrawLineInvert(m_nLeftCursor,0, m_nLeftCursor,m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   m_bPrevLeftCursor=TRUE;	 
	    //? should be time interval
	   FireCursorCurrentValues(1,m_nLeftCursor,m_nRightCursor,m_nRightCursor-m_nLeftCursor);
    }
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetRightCursor(long FAR* pPosition) 
{
	// TODO: Add your property handler here
    if(pPosition)
        *pPosition=m_nRightCursor;
	return m_bRightCursor;
}

void CYtvGraphCtrlCtrl::SetRightCursor(long FAR* pPosition, BOOL bNewValue) 
{
	// TODO: Add your property handler here
	if(m_bPrevRightCursor)
    {
       DrawLineInvert(m_nRightCursor, 0,m_nRightCursor,m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   m_bPrevRightCursor=FALSE;	   
    }
    if(pPosition)
        m_nRightCursor=*pPosition;
	m_nRightCursor%=m_ushMaxWidth; 
    m_bRightCursor=bNewValue;
    if(m_bRightCursor)
    {
       DrawLineInvert(m_nRightCursor,0, m_nRightCursor,m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   m_bPrevRightCursor=TRUE;	  
	   //? should be time interval
	   FireCursorCurrentValues(2,m_nRightCursor,m_nLeftCursor,m_nRightCursor-m_nLeftCursor);
      
    }

	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetTopCursor(long FAR* pPosition) 
{
	// TODO: Add your property handler here
    if(pPosition)
        *pPosition=m_nTopCursor;
	return m_bTopCursor;
}

void CYtvGraphCtrlCtrl::SetTopCursor(long FAR* pPosition, BOOL bNewValue) 
{
	// TODO: Add your property handler here
	int ind;
	if(m_bPrevTopCursor)
    {
       DrawLineInvert(0, m_nMaxGraphHeight-m_nTopCursor-1, m_ushMaxWidth-1,m_nMaxGraphHeight-m_nTopCursor-1,m_ushPaintBufNumber);
	   m_bPrevTopCursor=FALSE;	   
    }
    if(pPosition)
        m_nTopCursor=*pPosition;
	m_nTopCursor%=m_nMaxGraphHeight;
    m_bTopCursor=bNewValue;
	if(m_bTopCursor)
    {
       DrawLineInvert(0, m_nMaxGraphHeight-m_nTopCursor-1, m_ushMaxWidth-1,m_nMaxGraphHeight-m_nTopCursor-1,m_ushPaintBufNumber);
	   m_bPrevTopCursor=TRUE;	  
	   if(m_bComplexData)
       {
		   if(m_nTopCursor==(int)(m_nMaxGraphHeight-1)/2 ||m_nTopCursor==0||m_nTopCursor==(int)(m_nMaxGraphHeight-1))
			   ind=-1;
		   else if(m_nTopCursor>(int)(m_nMaxGraphHeight-1)/2)
			   ind=m_nTopCursor-2;
		   else
               ind=m_nTopCursor-1;
       }
	   else
       {
		   if(m_nTopCursor==0||m_nTopCursor==(int)(m_nMaxGraphHeight-1))
			   ind=-1;
		   else
			   ind=m_nTopCursor-1;
       }
	   ind+=ind;
	   if(ind>=0)//3 means top cursor
	     FireCursorCurrentValues(3,m_npMaxMinDataBuf[ind],ind/2,m_dpMaxMinDataBuf[ind]);
    }
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetBottomCursor(long FAR* pPosition) 
{
	// TODO: Add your property handler here
    if(pPosition)
        *pPosition=m_nBottomCursor;
	return m_bBottomCursor;
}

void CYtvGraphCtrlCtrl::SetBottomCursor(long FAR* pPosition, BOOL bNewValue) 
{
	// TODO: Add your property handler here
	int ind;
	if(m_bPrevBottomCursor)
    {
       DrawLineInvert(0, m_nMaxGraphHeight-m_nBottomCursor-1, m_ushMaxWidth-1,m_nMaxGraphHeight-m_nBottomCursor-1,m_ushPaintBufNumber);
	   m_bPrevBottomCursor=FALSE;	   
    }
    if(pPosition)
        m_nBottomCursor=*pPosition;
	m_nBottomCursor%=m_nMaxGraphHeight;
	m_bBottomCursor=bNewValue; 
	if(m_bBottomCursor)
    {
       DrawLineInvert(0, m_nMaxGraphHeight-m_nBottomCursor-1, m_ushMaxWidth-1,m_nMaxGraphHeight-m_nBottomCursor-1,m_ushPaintBufNumber);
	   m_bPrevBottomCursor=TRUE;	  
	   if(m_bComplexData)
       {
		   if(m_nBottomCursor==(int)(m_nMaxGraphHeight-1)/2 ||m_nBottomCursor==0||m_nBottomCursor==(int)(m_nMaxGraphHeight-1))
			   ind=-1;
		   else if(m_nBottomCursor>(int)(m_nMaxGraphHeight-1)/2)
			   ind=m_nBottomCursor-2;
		   else
               ind=m_nBottomCursor-1;
       }
	   else
       {
		   if(m_nBottomCursor==0||m_nBottomCursor==(int)(m_nMaxGraphHeight-1))
			   ind=-1;
		   else
			   ind=m_nBottomCursor-1;
       }
	   ind+=ind;
	   if(ind>=0)//4 means bottom cursor
	     FireCursorCurrentValues(4,m_npMaxMinDataBuf[ind+1],ind/2,m_dpMaxMinDataBuf[ind+1]);
    }
	SetModifiedFlag();
}

void CYtvGraphCtrlCtrl::SetInitMaxMinCoorY() 
{
	// TODO: Add your dispatch handler code here
    InitMaxMin();
}

BOOL CYtvGraphCtrlCtrl::GetReSizeHeight() 
{
	// TODO: Add your property handler here

	return m_bAutoResizeHeight;
}

void CYtvGraphCtrlCtrl::SetReSizeHeight(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bAutoResizeHeight=bNewValue;
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetCursors(short FAR* pCursors) 
{
	// TODO: Add your property handler here
    pCursors=m_pnCursorPositions;
	return m_ushNumberCursors;
}

void CYtvGraphCtrlCtrl::SetCursors(short FAR* pCursors, short nNewValue) 
{
	// TODO: Add your property handler here
    if(m_ushNumberCursors!=nNewValue)
		if(m_pnCursorPositions)
		{
			delete []m_pnCursorPositions;
			delete []m_pbCursorOn;
			delete []m_pnPrevCursorPositions;
            m_pnCursorPositions = NULL;
			m_pnPrevCursorPositions = NULL;
			m_pbCursorOn=NULL;
        }
    m_ushNumberCursors=nNewValue;
	if(m_pnCursorPositions==NULL && m_ushNumberCursors>0)
    {
		m_pnCursorPositions=new short[m_ushNumberCursors];
        m_pbCursorOn=new bool[m_ushNumberCursors];
		m_pnPrevCursorPositions=new short[m_ushNumberCursors];
    }
	if(m_ushNumberCursors>0 && m_pnCursorPositions!=NULL)
		memcpy(m_pnCursorPositions,pCursors,sizeof(short)*m_ushNumberCursors);
	for(int i=0;i<m_ushNumberCursors;i++)
    {
		m_pbCursorOn[i]=false;
		m_pnCursorPositions[i]=-1;
		m_pnPrevCursorPositions[i]=-1;
    }
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetCursorOnOff(short index) 
{
	// TODO: Add your property handler here

    if(index<0 || index>=m_ushNumberCursors || m_pbCursorOn==NULL)
		return FALSE;
	return m_pbCursorOn[index];
}
void CYtvGraphCtrlCtrl::SetCursorOnOff(short index, BOOL bNewValue) 
{
	// TODO: Add your property handler here
    if(m_pbCursorOn==NULL)
		return;
    if(index<0 || index>=m_ushNumberCursors)
	{
	  for(int i=0;i<m_ushNumberCursors;i++)
        m_pbCursorOn[i]=ChangeCursorState(bNewValue,i);
		return;
    }
	m_pbCursorOn[index]=ChangeCursorState(bNewValue,index);
	SetModifiedFlag();
}
bool CYtvGraphCtrlCtrl::ChangeCursorState(BOOL bNewValue,unsigned short index)
{
	if(m_pnCursorPositions[index]<0)
		return false;
	if(m_pbCursorOn[index]==(bool)bNewValue)
		return (bool)bNewValue;
	
	return (bool)bNewValue; 
}
void CYtvGraphCtrlCtrl::DrawDirectLineInvert(int xfrom, int yfrom, int xto, int yto,HDC hdc)
{
   int i,minp, maxp; 
   COLORREF clr;
   if(xfrom==xto)
   {
     if(yfrom>yto)
     {
        minp=yto;
		maxp=yfrom;
     }
	 else
     {
        minp=yfrom;
		maxp=yto;
     } 
     for(i=minp; i<=maxp;i++)
     {
		 clr=::GetPixel(hdc,xto,i);
		 clr^=0x00FFFFFF;
         ::SetPixel(hdc,xto,i,clr);
     }
   }
   else if(yto==yfrom)
   {
     if(xfrom>xto)
     {
        minp=xto;
		maxp=xfrom;
     }
	 else
     {
        minp=xfrom;
		maxp=xto;
     } 
     for(i=minp; i<=maxp;i++)
     {
		 clr=::GetPixel(hdc,i,yto);
		 clr^=0x00FFFFFF;
         ::SetPixel(hdc,i,yto,clr);
     }
   }

}

short CYtvGraphCtrlCtrl::GetCursorPosition(short index) 
{
	// TODO: Add your property handler here
    if(m_pbCursorOn==NULL)
		return-1;
    if(index<0 || index>=m_ushNumberCursors)
	    return-1;
	return m_pnCursorPositions[index];
}

void CYtvGraphCtrlCtrl::SetCursorPosition(short index, short nNewValue) 
{
	// TODO: Add your property handler here
    if(m_pbCursorOn==NULL)
		return;
    if(index<0 || index>=m_ushNumberCursors)
	    return;
    m_pnPrevCursorPositions[index]=m_pnCursorPositions[index];
	m_pnCursorPositions[index]=nNewValue;
	SetModifiedFlag();
}

void CYtvGraphCtrlCtrl::DrawVerticalCursors() 
{
	// TODO: Add your dispatch handler code here
 if(m_pbCursorOn==NULL)
		return;
 for(int i=0; i<m_ushNumberCursors;i++)
 {  
	if(m_pnPrevCursorPositions[i]>=0)
    {
       DrawLineInvert(m_pnPrevCursorPositions[i], 0,m_pnPrevCursorPositions[i],m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   m_pnPrevCursorPositions[i]=-1;	   
    }
	if(m_pbCursorOn[i]==FALSE)
		return;
    if(m_pnCursorPositions[i]>=0)
    {
       DrawLineInvert(m_pnCursorPositions[i],0, m_pnCursorPositions[i],m_nMaxGraphHeight-1,m_ushPaintBufNumber);
	   FireCursorCurrentValues(i,m_pnCursorPositions[i],m_ushNumberCursors,0);
    }
 }
}

long CYtvGraphCtrlCtrl::GetIPoints(long FAR* PointsArray) 
{
	// TODO: Add your property handler here
    for(int i = 0;  i<m_nMemorySize;i++)
	{
		PointsArray[i]=(long)m_dpDataBuf[i];	
    }
	return m_nMemorySize;	
}

void CYtvGraphCtrlCtrl::SetIPoints(long FAR* PointsArray, long nNewValue) 
{
	// TODO: Add your property handler here
	SetMaxWidth((short)nNewValue); 
    UpdateMemorySize(nNewValue); 
	for(int i=0; i<m_nMemorySize; i++)
    {
		m_dpDataBuf[i]=(double)PointsArray[i];
        SetMaxMinDataAtPosition(i);
    }
    if(m_bComplexData)
	      m_uNumberPoints=m_nMemorySize/2;
	else
          m_uNumberPoints=m_nMemorySize;
    InitXCoor();
	InitYCoor();
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetOcuMethod() 
{
	// TODO: Add your property handler here
	return m_bOcu;
}

void CYtvGraphCtrlCtrl::SetOcuMethod(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bOcu=bNewValue;
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetScalePlank(short FAR* BegX, short FAR* BegY, short FAR* LenX, short FAR* LenY, short FAR* HSmall, short FAR* HMedium, short FAR* HLong, short FAR* StepSmall, short FAR* StepMedium, short FAR* StepLong, short FAR* DirectionUpDownCenter, short FAR* AxisLineType) 
{
	// TODO: Add your property handler here
    *BegX=m_shBegXH;
	*BegY=m_shBegYH;
	*LenX=m_shLenXH;
	*LenY=m_shLenYH;
	*HSmall=m_shHSmall;
	*HMedium=m_shHMedium;
	*HLong=m_shHLong;
	*StepSmall=m_shStepSmallH;
	*StepMedium=m_shStepMediumH;
	*StepLong=m_shStepLongH;
	*DirectionUpDownCenter=m_shDirectionUpDownCenterH;
	*AxisLineType=m_shAxisLineTypeH;
	return 0;
}

void CYtvGraphCtrlCtrl::SetScalePlank(short FAR* BegX, short FAR* BegY, short FAR* LenX, short FAR* LenY, short FAR* HSmall, short FAR* HMedium, short FAR* HLong, short FAR* StepSmall, short FAR* StepMedium, short FAR* StepLong, short FAR* DirectionUpDownCenter, short FAR* AxisLineType, short nNewValue) 
{
	// TODO: Add your property handler here
    m_shBegXH=*BegX;
	m_shBegYH=*BegY;
	m_shLenXH=*LenX;
	m_shLenYH=*LenY;
	m_shHSmall=*HSmall;
	m_shHMedium=*HMedium;
	m_shHLong=*HLong;
	m_shStepSmallH=*StepSmall;
	m_shStepMediumH=*StepMedium;
	m_shStepLongH=*StepLong;
	m_shDirectionUpDownCenterH=*DirectionUpDownCenter;
	m_shAxisLineTypeH=*AxisLineType;
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetDrawScalePlank() 
{
	// TODO: Add your property handler here
	return m_shVisibilityState;
}

void CYtvGraphCtrlCtrl::SetDrawScalePlank(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_shVisibilityState=(short)bNewValue;
	SetModifiedFlag();
}
void CYtvGraphCtrlCtrl::DrawScalePlankHoriz(HDC hdc)
{
    if(m_shVisibilityState==0)
		return;
    m_OldPen=(CPen*)::SelectObject(hdc,m_penScalePlankPen);
	COLORREF oldtc=::SetTextColor(hdc,m_clrScalePlankColor);
	COLORREF oldbc=::SetBkColor(hdc,m_clrScaleBackPlankColor);
	int i,endX=m_shBegXH+m_shLenXH,topY,bottomY,count,Beg;
	CString Temp;
    if(m_shAxisLineTypeH)
    {
       MoveToEx(hdc,m_shBegXH,m_shBegYH,NULL);
	   LineTo(hdc,endX,m_shBegYH+m_shLenYH);
    }
  if(m_shHSmall)
  {
    count=m_nFontScaleCountBeginH; 
	bottomY=m_shBegYH;
	if(m_shDirectionUpDownCenterH==1)
	    topY=m_shBegYH+m_shHSmall;
	else if(m_shDirectionUpDownCenterH==-1)
        topY=m_shBegYH-m_shHSmall;
	else
        if(m_shDirectionUpDownCenterH==0)
        {
			topY=m_shBegYH+m_shHSmall/2;
            bottomY=m_shBegYH-m_shHSmall/2;
        }
    Beg=m_shBegXH+m_shHLong!=0&&m_shHMedium!=0?0:m_shStepSmallH;
	if(Beg!=m_shBegXH)
		count+=m_shStepSmallH;
	for(i=Beg;i<=endX;i+=m_shStepSmallH,count+=m_nScaleTextStepHS)
    {
		if(m_shHLong && (i-m_shBegXH)%m_shStepLongH==0)
			continue;
		if(m_shHMedium && (i-m_shBegXH)%m_shStepMediumH==0)
			continue;
        MoveToEx(hdc,i,bottomY,NULL);
        LineTo(hdc,i,topY);
		if(m_nScaleTextStepHS)
		{			
			Temp.Format("%d",count);
            ::TextOut(hdc,i+1,topY,Temp,Temp.GetLength()); 			
        }
    }
  }
  ////////////////////////////////////////
  if(m_shHMedium)
  {
    count=m_nFontScaleCountBeginH; 
	bottomY=m_shBegYH;
	if(m_shDirectionUpDownCenterH==1)
	    topY=m_shBegYH+m_shHMedium;
	else if(m_shDirectionUpDownCenterH==-1)
        topY=m_shBegYH-m_shHMedium;
	else
        if(m_shDirectionUpDownCenterH==0)
        {
			topY=m_shBegYH+m_shHMedium/2;
            bottomY=m_shBegYH-m_shHMedium/2;
        }
	Beg=m_shBegXH+m_shHLong>0?0:m_shStepMediumH;
	if(Beg!=m_shBegXH)
		count+=m_shStepMediumH;
	for(i=Beg;i<=endX;i+=m_shStepMediumH,count+=m_nScaleTextStepHM)
    {
        if(m_shHLong && (i-m_shBegXH)%m_shStepLongH==0)
			continue;
        MoveToEx(hdc,i,bottomY,NULL);
        LineTo(hdc,i,topY);
		if(m_nScaleTextStepHM)
		{
			Temp.Format("%d",count);
            ::TextOut(hdc,i+1,topY,Temp,Temp.GetLength());			
        }		
    }
  }
///////////////////////
  if(m_shHLong)
  {
    count=m_nFontScaleCountBeginH; 
	bottomY=m_shBegYH;
	if(m_shDirectionUpDownCenterH==1)
	    topY=m_shBegYH+m_shHLong;
	else if(m_shDirectionUpDownCenterH==-1)
        topY=m_shBegYH-m_shHLong;
	else
        if(m_shDirectionUpDownCenterH==0)
        {
			topY=m_shBegYH+m_shHLong/2;
            bottomY=m_shBegYH-m_shHLong/2;
        }
	for(i=m_shBegXH;i<=endX;i+=m_shStepLongH)
    {
        MoveToEx(hdc,i,bottomY,NULL);
        LineTo(hdc,i,topY);
		if(m_nScaleTextStepHL)
		{			
			Temp.Format("%d",count);
            ::TextOut(hdc,i+1,topY,Temp,Temp.GetLength());
			count+=m_nScaleTextStepHL;
        }
    }
  }
  ::SelectObject(hdc,m_OldPen);
  ::SetTextColor(hdc,oldtc);
  ::SetBkColor(hdc,oldbc);
}

long CYtvGraphCtrlCtrl::GetScalePlankColor() 
{
	// TODO: Add your property handler here
	return m_clrScalePlankColor;
}

void CYtvGraphCtrlCtrl::SetScalePlankColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrScalePlankColor=nNewValue;
	m_penScalePlankPen.DeleteObject();
	m_penScalePlankPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrScalePlankColor);
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetCleanByBrush() 
{
	// TODO: Add your property handler here
	return m_bCleanByBrush;
}

void CYtvGraphCtrlCtrl::SetCleanByBrush(BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bCleanByBrush=bNewValue;
	SetModifiedFlag();
}

short CYtvGraphCtrlCtrl::GetDrawLines(short FAR* pX, short FAR* pY, short FAR* pType) 
{
	// TODO: Add your property handler here
	if(!m_pListCoor)
		return 0;
    for(int i=0; i<m_ushListNumberPoints;i++)
    {
       if(pX)
		   pX[i]=m_pListCoor[i+i+i];
	   if(pY)
		   pY[i]=m_pListCoor[i+i+i+1];
	   if(pType)
		   pType[i]=m_pListCoor[i+i+i+2];
    }
	return m_ushListNumberPoints;
}
void CYtvGraphCtrlCtrl::DrawLines(HDC hdc,CPen* ppen)
{
	if(!m_pListCoor)
		return;
	CPen* OldPen=(CPen*)::SelectObject(hdc,*ppen);
    for(int i=0; i<m_ush3ListNumberPoints;i+=3)
    {
        if(m_pListCoor[i+2]==1)
			LineTo(hdc,m_pListCoor[i],m_pListCoor[i+1]);
		else if(m_pListCoor[i+2]==0)
			MoveToEx(hdc,m_pListCoor[i],m_pListCoor[i+1],NULL);
    }
	::SelectObject(hdc,OldPen);
}
void CYtvGraphCtrlCtrl::SetDrawLines(short FAR* pX, short FAR* pY, short FAR* pType, short nNewValue) 
{
	// TODO: Add your property handler here
    if(m_ushListNumberPoints<nNewValue)
	{
		if(m_pListCoor)
		   delete m_pListCoor;
		m_pListCoor=new short[nNewValue+nNewValue+nNewValue+nNewValue];
	}
	else if(!m_pListCoor)
		   	m_pListCoor=new short[nNewValue+nNewValue+nNewValue+nNewValue];
	m_ushListNumberPoints=nNewValue;
	m_ush3ListNumberPoints=m_ushListNumberPoints+m_ushListNumberPoints+m_ushListNumberPoints;
	if(!m_pListCoor)
		return;
	RECT rt;
	GetWindowRect(&rt);
	rt.bottom-=rt.top;
    for(int i=0; i<m_ushListNumberPoints;i++)
    {
       if(pX)
		   m_pListCoor[i+i+i]=pX[i];
	   else
		   m_pListCoor[i+i+i]=0;
	   if(pY)
		   m_pListCoor[i+i+i+1]=rt.bottom-pY[i];
	   else
           m_pListCoor[i+i+i+1]=0;
	   if(pType)
		   m_pListCoor[i+i+i+2]=pType[i];
	   else
           m_pListCoor[i+i+i+2]=0;
    }
	SetModifiedFlag();
}

void CYtvGraphCtrlCtrl::CleanReDraw(short CleanRedraw) 
{
	// TODO: Add your dispatch handler code here
	  CPen* OldPen;
      CClientDC dc(this); // device context for painting
      if(CleanRedraw==0)
	  {
         OldPen=dc.SelectObject(&m_penChartBrushPen);
		 DrawLines(dc.m_hDC,&m_penChartBrushPen);
         dc.Polyline(m_ptPoints, m_uNumberPoints);		
      }
	  else if(CleanRedraw==1)
	  {
		  OldPen=dc.SelectObject(&m_penChartPen);          
          dc.Polyline(m_ptPoints, m_uNumberPoints);		 
		  DrawLines(dc.m_hDC,&m_penScalePlankPen);
      }
	  else if(CleanRedraw==-1)
      {
          RECT rcBounds;
	      GetWindowRect(&rcBounds);
	      rcBounds.right-=rcBounds.left;
		  rcBounds.bottom-=rcBounds.top;
	      rcBounds.left=rcBounds.top=0;
          dc.SetBkColor(m_clrChartBrush);	  	  
	      dc.FillRect(&rcBounds,&m_cbrChartBrush);
		  Invalidate();
		  return;
      }
	  dc.SelectObject(OldPen);
}

BOOL CYtvGraphCtrlCtrl::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return COleControl::OnChildNotify(message, wParam, lParam, pLResult);
}

long CYtvGraphCtrlCtrl::GetScalePlankTextHoriz(long FAR* StepSmall, long FAR* StepMedium, long FAR* StepLong) 
{
	// TODO: Add your property handler here
	if(StepLong)
   	    *StepLong=m_nScaleTextStepHL;
	if(StepMedium)
	    *StepMedium=m_nScaleTextStepHM;
	if(StepSmall)
	    *StepSmall=m_nScaleTextStepHS;
	return m_nFontScaleCountBeginH;
}
void CYtvGraphCtrlCtrl::SetScalePlankTextHoriz(long FAR* StepSmall, long FAR* StepMedium, long FAR* StepLong, long nNewValue) 
{
	// TODO: Add your property handler here
    m_nFontScaleCountBeginH=nNewValue;
    if(StepLong)
   	    m_nScaleTextStepHL=*StepLong;
	if(StepMedium)
	    m_nScaleTextStepHM=*StepMedium;
	if(StepSmall)
	    m_nScaleTextStepHS=*StepSmall;
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetHPosionLeft() 
{
	// TODO: Add your property handler here
	return m_nHPosionLeft;
}

void CYtvGraphCtrlCtrl::SetHPosionLeft(long nNewValue) 
{
	// TODO: Add your property handler here
    m_nHPosionLeft=nNewValue;
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetHPositionRight() 
{
	// TODO: Add your property handler here	
	return m_nHPosionRight;
}

void CYtvGraphCtrlCtrl::SetHPositionRight(long nNewValue) 
{
	// TODO: Add your property handler here
    m_nHPosionRight=nNewValue;
	SetModifiedFlag();
}



long CYtvGraphCtrlCtrl::GetBackTextColor() 
{
	// TODO: Add your property handler here
	return m_clrScaleBackPlankColor;
}

void CYtvGraphCtrlCtrl::SetBackTextColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrScaleBackPlankColor=nNewValue;
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetBottomVerticalPosition() 
{
	// TODO: Add your property handler here
	return m_nVPosTop;
}

void CYtvGraphCtrlCtrl::SetBottomVerticalPosition(long nNewValue) 
{
	// TODO: Add your property handler here
    m_nVPosTop=nNewValue;
	SetModifiedFlag();
}
long CYtvGraphCtrlCtrl::GetTopVerticalPosition() 
{
	// TODO: Add your property handler here
	return m_nVPosBottom;
}

void CYtvGraphCtrlCtrl::SetTopVerticalPosition(long nNewValue) 
{
	// TODO: Add your property handler here
    m_nVPosBottom=nNewValue;
	InitYCoor();
	SetModifiedFlag();
}
long CYtvGraphCtrlCtrl::PixelsFromUnitsLength(double LengthInUnits) 
{
	// TODO: Add your dispatch handler code here    
	return m_shStepSmallH!=0?(long)(LengthInUnits*m_shStepSmallH+0.5):1;
}

double CYtvGraphCtrlCtrl::UnitsLengthFromPixels(long NumberPixels) 
{
	// TODO: Add your dispatch handler code here
	return m_shStepSmallH!=0?(double)NumberPixels/(double)m_shStepSmallH+0.5:0.0;
}

long CYtvGraphCtrlCtrl::PixelFromDataXCoor(long InpDataXCoor) 
{
	// TODO: Add your dispatch handler code here
	RECT rt;
	double multif;
	if(m_nMemorySize==0)
		return 0;
    if(InpDataXCoor==0)
		return m_nHPosionLeft;
	GetClientRect(&rt);
	rt.right-=m_nHPosionLeft+m_nHPosionRight-1;
	if(m_bComplexData)
    {
        rt.right+=rt.right;
		multif=m_dHMultifactor==0.0?(double)rt.right/(double)m_nMemorySize:m_dHMultifactor;
    }
	else
        multif=m_dHMultifactor==0.0?(double)rt.right/(double)m_nMemorySize:m_dHMultifactor;
	return (long)(multif*(double)(InpDataXCoor+1));

}
double CYtvGraphCtrlCtrl::UnitLengthFromInpDataInputCoorX(long DataInpCoorX) 
{
	// TODO: Add your dispatch handler code here
	return UnitsLengthFromPixels(PixelFromDataXCoor(DataInpCoorX));
}


long CYtvGraphCtrlCtrl::InpXCoorFromPixels(long Pixels) 
{
	// TODO: Add your dispatch handler code here
    RECT rt;
	int ind;
	double multif;
	if(m_nMemorySize==0)
		return 0;
    if(Pixels==0)
		return m_nHPosionLeft;
	GetClientRect(&rt);
	rt.right-=m_nHPosionLeft+m_nHPosionRight-1;
	if(m_bComplexData)
    {
        rt.right+=rt.right;
		multif=m_dHMultifactor==0.0?(double)m_nMemorySize/(double)rt.right:1.0/m_dHMultifactor;
        multif*=(double)Pixels;
	    ind =(int)(multif+0.5);
		if(ind>=m_nMemorySize/2)
			ind=m_nMemorySize/2-1;
	}
	else
    {
		multif=m_dHMultifactor==0.0?(double)m_nMemorySize/(double)rt.right:1.0/m_dHMultifactor;
	    multif*=(double)Pixels;
	    ind =(int)(multif+0.5);
        if(ind>=m_nMemorySize)
			ind=m_nMemorySize-1;
    }
	if(ind<0)
		ind=0;
	return ind;
}

long CYtvGraphCtrlCtrl::GetExternalDeviceContext() 
{
	// TODO: Add your property handler here
	return (long)m_hExternalDC;
}

void CYtvGraphCtrlCtrl::SetExternalDeviceContext(long nNewValue) 
{
	// TODO: Add your property handler here
    m_hExternalDC=(HDC)nNewValue;
	SetModifiedFlag();
}

BOOL CYtvGraphCtrlCtrl::GetExternalDeviceContextRectangle(short FAR* pleft, short FAR* ptop, short FAR* pwidth, short FAR* pheight) 
{
	// TODO: Add your property handler here
	if(pleft)
        *pleft=(short)m_rectExternalDevice.left;
	if(ptop)
		*ptop=(short)m_rectExternalDevice.top;
	if(pwidth)
		*pwidth=(short)m_rectExternalDevice.right-m_rectExternalDevice.left+1;
	if(pheight)
		*pheight=(short)m_rectExternalDevice.bottom-m_rectExternalDevice.top+1;
	return m_bMakeOutputToExternalDC;
}

void CYtvGraphCtrlCtrl::SetExternalDeviceContextRectangle(short FAR* pleft, short FAR* ptop, short FAR* pwidth, short FAR* pheight, BOOL bNewValue) 
{
	// TODO: Add your property handler here
    m_bMakeOutputToExternalDC=bNewValue;
	if(pleft)
        m_rectExternalDevice.left=*pleft;
	if(ptop)
		m_rectExternalDevice.top=*ptop;
	if(pwidth)
		m_rectExternalDevice.right=m_rectExternalDevice.left+*pwidth-1;
	if(pheight)
		m_rectExternalDevice.bottom=m_rectExternalDevice.top+*pheight-1;
	if(m_bMakeOutputToExternalDC)
		OnPaint();
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetChartLineColor() 
{
	// TODO: Add your property handler here
	return m_clrChartPen;
}

void CYtvGraphCtrlCtrl::SetChartLineColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrChartPen=nNewValue;
	m_penChartPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartPen);	
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetChartBrushColor() 
{
	// TODO: Add your property handler here
	return m_clrChartBrush;
}

void CYtvGraphCtrlCtrl::SetChartBrushColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrChartBrush=nNewValue;
    m_cbrChartBrush.CreateSolidBrush(m_clrChartBrush);
    m_penChartBrushPen.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartBrush);
	SetModifiedFlag();
}

long CYtvGraphCtrlCtrl::GetChartLineSecondColor() 
{
	// TODO: Add your property handler here
	return m_clrChartPenIm;
}

void CYtvGraphCtrlCtrl::SetChartLineSecondColor(long nNewValue) 
{
	// TODO: Add your property handler here
    m_clrChartPenIm=nNewValue;
	m_penChartPenIm.CreatePen(m_nPenChartStyle,m_nPenChartWidth,m_clrChartPenIm);
	SetModifiedFlag();
}
