// PersonalACD.cpp : implementation file
//

#include "stdafx.h"
//#include "ytvultrasoundmedscan0.h"
#include "PersonalACD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PersonalACD dialog


PersonalACD::PersonalACD(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	//{{AFX_DATA_INIT(PersonalACD)
	m_szPersonAl = _T("");
	m_szPersonIOL = _T("");
	m_szPersonK = _T("");
	m_szPORef = _T("");
	m_strValidMessage = _T("");
	//}}AFX_DATA_INIT
	m_dPersonAl=0.0;
	m_dPersonIOL=0.0;
	m_dPersonK=0.0;
	m_dPORef=0.0;
    m_dPersACD=0.0;
	m_dPersSF=0.0;
	m_dPersA_Const=0.0;
	m_nSelectedPersonalLens=0;
	m_szMarkSel.Empty();
		m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,255,255); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(255,255,255);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,255); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,255);
	m_clrEditBoxesFront=RGB(0,0,0);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
}


void PersonalACD::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PersonalACD)
	DDX_Control(pDX, IDC_ED_PERSONAL_POREF, m_edEOREF);
	DDX_Control(pDX, IDCANCEL, m_BtCancel);
	DDX_Control(pDX, IDOK, m_btOk);
	DDX_Control(pDX, IDC_ED_PERSONAL_K, m_cntrPersonK);
	DDX_Control(pDX, IDC_ED_PERSONAL_IOL, m_cntrPersonIOL);
	DDX_Control(pDX, IDC_ED_AL, m_cntrPersonAl);
	DDX_Control(pDX, IDC_BU_PERSONAL_CLEAR, m_cntrPersonClear);
	DDX_Control(pDX, IDC_BU_PERSONAL_CALC, m_cntrPersonCalc);
	DDX_Control(pDX, IDC_BU_PERSONAL_APPLY, m_cntrPersonApply);
	DDX_Control(pDX, IDC_PERSONAL_DOCTOR_NAME, m_gridPersonalDoctorName);
	DDX_Control(pDX, IDC_PERSONAL_SEL_LENS, m_gridPersonalSelLens);
	DDX_Control(pDX, IDC_PERSONAL_CALCULATION_TABLE, m_gridPersonalCalculation);
	DDX_Control(pDX, IDC_PERSONAL_AVG, m_gridPersonalAverage);
	DDX_Text(pDX, IDC_ED_AL, m_szPersonAl);
	DDX_Text(pDX, IDC_ED_PERSONAL_IOL, m_szPersonIOL);
	DDX_Text(pDX, IDC_ED_PERSONAL_K, m_szPersonK);
	DDX_Text(pDX, IDC_ED_PERSONAL_POREF, m_szPORef);
	DDX_Text(pDX, IDC_VALIDATION_PERS_MESSAGE, m_strValidMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PersonalACD, CDialog)
	//{{AFX_MSG_MAP(PersonalACD)
	ON_BN_CLICKED(IDC_BU_PERSONAL_APPLY, OnBuPersonalApply)
	ON_BN_CLICKED(IDC_BU_PERSONAL_CALC, OnBuPersonalCalc)
	ON_BN_CLICKED(IDC_BU_PERSONAL_CLEAR, OnBuPersonalClear)
	ON_WM_CTLCOLOR()
	ON_EN_CHANGE(IDC_ED_AL, OnChangeEdAl)
	ON_EN_CHANGE(IDC_ED_PERSONAL_IOL, OnChangeEdPersonalIol)
	ON_EN_CHANGE(IDC_ED_PERSONAL_K, OnChangeEdPersonalK)
	ON_EN_CHANGE(IDC_ED_PERSONAL_POREF, OnChangeEdPersonalPoref)
	ON_EN_KILLFOCUS(IDC_ED_AL, OnKillfocusEdAl)
	ON_EN_KILLFOCUS(IDC_ED_PERSONAL_IOL, OnKillfocusIol)
	ON_EN_KILLFOCUS(IDC_ED_PERSONAL_K, OnKillfocusK)
	ON_EN_KILLFOCUS(IDC_ED_PERSONAL_POREF, OnKillfocusEdPersonalPoref)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PersonalACD message handlers

BOOL PersonalACD::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ShowWindow(SW_MAXIMIZE);
	// TODO: Add extra initialization here
	CString Temp;
	int rows,cols,c,r;
	m_gridPersonalDoctorName.SetCols(2);
	m_gridPersonalDoctorName.SetRows(1);
	m_gridPersonalDoctorName.SetFixedRows(0);
    m_gridPersonalDoctorName.SetColWidth(0,1250);
    m_gridPersonalDoctorName.SetColWidth(1,3800);	
	m_gridPersonalDoctorName.SetTextMatrix(0, 0, "Doctor Name");
	Temp=m_szDFirstName+' '+m_szDLastName;
	m_gridPersonalDoctorName.SetTextMatrix(0,1,Temp);
  /////////////////////////////////////////////////////////////
	m_gridPersonalSelLens.SetRows(2);
	m_gridPersonalSelLens.SetCols(8);
	m_gridPersonalSelLens.SetFixedCols(0);
	m_gridPersonalSelLens.SetColWidth(0,1000);
	m_gridPersonalSelLens.SetColWidth(1,1000);
	m_gridPersonalSelLens.SetColWidth(2,1000);
	m_gridPersonalSelLens.SetColWidth(3,1000);
	m_gridPersonalSelLens.SetColWidth(4,1000);
	m_gridPersonalSelLens.SetColWidth(5,1000);	
	m_gridPersonalSelLens.SetColWidth(6,1000);
	m_gridPersonalSelLens.SetColWidth(7,1020);
	m_gridPersonalSelLens.SetTextMatrix(0, 0, "Lens Mfg");   
    m_gridPersonalSelLens.SetTextMatrix(0, 1, "Lens Name");
	m_gridPersonalSelLens.SetTextMatrix(0, 2, "Mfg A-Const");
	m_gridPersonalSelLens.SetTextMatrix(0, 3, "pA-Const");
	m_gridPersonalSelLens.SetTextMatrix(0, 4, "Mfg ACD");
	m_gridPersonalSelLens.SetTextMatrix(0, 5, "pACD");
	m_gridPersonalSelLens.SetTextMatrix(0, 6, "Mfg SF");
	m_gridPersonalSelLens.SetTextMatrix(0, 7, "pSF");
	if(m_pDLensGrid)
    {
     cols=m_pDLensGrid->GetCols();
	 rows=m_pDLensGrid->GetRows();
	 for(r=1;r<rows;r++)
     {
		Temp=m_pDLensGrid->GetTextMatrix(r,0);
		if(Temp!=m_szMarkSel)
			continue;
		for(c=1;c<cols;c++)
        {          
            Temp=m_pDLensGrid->GetTextMatrix(r,c);
            m_gridPersonalSelLens.SetTextMatrix(1,c-1,Temp);
			m_nSelectedPersonalLens=r;
        }
		break;
     }
    }
	/////////////////////////////////////////////
	m_gridPersonalCalculation.SetRows(11);
	m_gridPersonalCalculation.SetCols(7);
	m_gridPersonalCalculation.SetFixedCols(0);
	m_gridPersonalCalculation.SetTextMatrix(0, 0, "AL");   
    m_gridPersonalCalculation.SetTextMatrix(0, 1, "K-Value");
	m_gridPersonalCalculation.SetTextMatrix(0, 2, "IOL");
	m_gridPersonalCalculation.SetTextMatrix(0, 3, "P.O.Ref");
	m_gridPersonalCalculation.SetTextMatrix(0, 4, "cACD");
	m_gridPersonalCalculation.SetTextMatrix(0, 5, "cA-Const");
	m_gridPersonalCalculation.SetTextMatrix(0, 6, "cSF");
	m_gridPersonalCalculation.SetColWidth(0,1000);
	m_gridPersonalCalculation.SetColWidth(1,1000);
	m_gridPersonalCalculation.SetColWidth(2,1000);
	m_gridPersonalCalculation.SetColWidth(3,1000);
	m_gridPersonalCalculation.SetColWidth(4,1000);	
	m_gridPersonalCalculation.SetColWidth(5,1000);
	m_gridPersonalCalculation.SetColWidth(6,1020);
	rows=m_gridPersonalCalculation.GetRows();
	cols=m_gridPersonalCalculation.GetCols();
    for(r=1;r<rows;r++)
       for(c=0;c<cols;c++)
          m_gridPersonalCalculation.SetTextMatrix(r,c,"0");
	/////////////////////////////////////////////////
	m_gridPersonalAverage.SetCols(4);
	m_gridPersonalAverage.SetRows(1);
	m_gridPersonalAverage.SetFixedRows(0);
    m_gridPersonalAverage.SetColWidth(0,1000);
    m_gridPersonalAverage.SetColWidth(1,1000); 
	m_gridPersonalAverage.SetColWidth(2,1000); 
	m_gridPersonalAverage.SetColWidth(3,1009); 
	m_gridPersonalAverage.SetTextMatrix(0, 0, "Average"); 
	m_gridPersonalCalculation.SetRow(1);
    m_gridPersonalCalculation.SetRowSel(1);
    m_cntrPersonAl.SetFocus();
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void PersonalACD::OnOK() 
{
	// TODO: Add extra validation here
	if(::GetFocus() != ::GetDlgItem (m_hWnd, IDOK))
	{
	    NextDlgCtrl(); // Tab to next edit box
		return;
    }
	if(m_nSelectedPersonalLens>0 && m_pDLensGrid)
    {
      int cols=m_pDLensGrid->GetCols(); 
      for(int c=1;c<cols;c++)
          m_pDLensGrid->SetTextMatrix(m_nSelectedPersonalLens,c,m_gridPersonalSelLens.GetTextMatrix(1,c-1));
    }
	m_pw->UpdateData(FALSE);
//	ShowWindow(SW_RESTORE);
	DestroyWindow();
	delete this;
	//CDialog::OnOK();
}

void PersonalACD::OnBuPersonalApply() 
{
	// TODO: Add your control notification handler code here
   m_gridPersonalSelLens.SetTextMatrix(1,3,m_gridPersonalAverage.GetTextMatrix(0,1));
   m_gridPersonalSelLens.SetTextMatrix(1,5,m_gridPersonalAverage.GetTextMatrix(0,2));
   m_gridPersonalSelLens.SetTextMatrix(1,7,m_gridPersonalAverage.GetTextMatrix(0,3));
}

void PersonalACD::OnBuPersonalCalc() 
{
	// TODO: Add your control notification handler code here
	int c,r,cols,rows;
	CString szPersonAl;
	CString szPersonIOL;
	CString szPersonK;
	CString szPORef;
	CString Temp;
	unsigned int n=0;
    OnChangeEdAl();
	OnChangeEdPersonalIol();
	OnChangeEdPersonalK();
	OnChangeEdPersonalPoref();     
	//compute and average total
	m_pfAverages[0]=m_pfAverages[1]=m_pfAverages[2]=0.0;
	rows=m_gridPersonalCalculation.GetRows();
	cols=m_gridPersonalCalculation.GetCols();
	m_dPersACD=0.0;
    for(r=1,n=1;r<rows;r++,n++)
    {
       szPersonAl=m_gridPersonalCalculation.GetTextMatrix(r,0);
	   szPersonK=m_gridPersonalCalculation.GetTextMatrix(r,1);
       szPersonIOL=m_gridPersonalCalculation.GetTextMatrix(r,2);
	   szPORef=m_gridPersonalCalculation.GetTextMatrix(r,3);
       m_dPersonAl=atof(szPersonAl);
	   m_dPersonIOL=atof(szPersonIOL);
	   m_dPersonK=atof(szPersonK);
	   m_dPORef=atof(szPORef);
	   if(m_dPersonAl==0.0 && m_dPersonIOL==0.0&&m_dPersonK==0.0&&m_dPORef==0.0)
            continue;
       PersAcdMETHOD1Formula(m_dPersonIOL,m_dPORef,m_dPersonAl,m_dPersonK,&m_dPersACD,&n);
	   METHOD0FormulaReverseSFSol(m_dPersonIOL,m_dPORef,m_dPersonAl,m_dPersonK,&m_dPersSF,12);
	   Srk_tGetA_Const(&m_dPersA_Const, m_dPersonIOL, m_dPersonAl,m_dPORef,m_dPersonK);
	   Temp.Format("%1.2f",m_dPersACD);
	   Temp.TrimLeft();
       m_gridPersonalCalculation.SetTextMatrix(r,4,Temp);
	   Temp.Format("%3.1f",m_dPersA_Const);
	   Temp.TrimLeft();
       m_gridPersonalCalculation.SetTextMatrix(r,5,Temp);	  
	   Temp.Format("%1.2f",m_dPersSF);
	   Temp.TrimLeft();
       m_gridPersonalCalculation.SetTextMatrix(r,6,Temp);
	   for(c=4;c<cols;c++)
       {
          Temp=m_gridPersonalCalculation.GetTextMatrix(r,c);
		  Temp.TrimLeft();
          m_pfAverages[c-4]+=atof(Temp);
       }
	}
	n--;
	if(n>0)
	{
		Temp.Format("%1.2f",m_pfAverages[0]/(double)n);
		Temp.TrimLeft();
        m_gridPersonalAverage.SetTextMatrix(0,1,Temp);
        Temp.Format("%3.1f",m_pfAverages[1]/(double)n);
		Temp.TrimLeft();
        m_gridPersonalAverage.SetTextMatrix(0,2,Temp);
        Temp.Format("%1.2f",m_pfAverages[2]/(double)n);
		Temp.TrimLeft();
        m_gridPersonalAverage.SetTextMatrix(0,3,Temp);
    }
}

void PersonalACD::OnBuPersonalClear() 
{
	// TODO: Add your control notification handler code here
   m_gridPersonalSelLens.SetTextMatrix(1,3,"");
   m_gridPersonalSelLens.SetTextMatrix(1,5,"");
   m_gridPersonalSelLens.SetTextMatrix(1,7,"");
}

HBRUSH PersonalACD::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	
	// TODO: Change any attributes of the DC here
	switch(nCtlColor)
	{
		default:

			return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
        case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	// TODO: Return a different brush if the default is not desired
	
}

void PersonalACD::OnChangeEdAl() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int row=m_gridPersonalCalculation.GetRowSel();
	if(row<1)
      return;
	UpdateData();
	m_gridPersonalCalculation.SetTextMatrix(row,0,m_szPersonAl);

}

void PersonalACD::OnChangeEdPersonalIol() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	int row=m_gridPersonalCalculation.GetRowSel();
	if(row<1)
      return;
	UpdateData();
	m_gridPersonalCalculation.SetTextMatrix(row,2,m_szPersonIOL);
	// TODO: Add your control notification handler code here
	
}

void PersonalACD::OnChangeEdPersonalK() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	int row=m_gridPersonalCalculation.GetRowSel();
	if(row<1)
      return;
	UpdateData();
	m_gridPersonalCalculation.SetTextMatrix(row,1,m_szPersonK);
	// TODO: Add your control notification handler code here
	
}

void PersonalACD::OnChangeEdPersonalPoref() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.	
	// TODO: Add your control notification handler code here
	int row=m_gridPersonalCalculation.GetRowSel();
	if(row<1)
      return;
	UpdateData();
	m_gridPersonalCalculation.SetTextMatrix(row,3,m_szPORef);
}

void PersonalACD::OnCancel() 
{
	// TODO: Add extra cleanup here
	DestroyWindow();
    delete this;
	//CDialog::OnCancel();
}

BOOL PersonalACD::Create(CWnd* pParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pw=pParentWnd;
	return CDialog::Create(IDD, pParentWnd);
}

void PersonalACD::OnKillfocusEdAl() 
{
	// TODO: Add your control notification handler code here
     UpdateData();
	 double temp=atof(m_szPersonAl);
	 if(temp>=15.0 && temp<=40.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Personal AL is invalid (15<=AL<=40)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrPersonAl.SetFocus();
	 UpdateData(FALSE);	
}

void PersonalACD::OnKillfocusIol() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szPersonIOL);
	 if(temp>=0.0 && temp<=40.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Personal IOL is invalid  (0<=IOL<=40)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrPersonIOL.SetFocus();
	 UpdateData(FALSE);
}

void PersonalACD::OnKillfocusK() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szPersonK);
	 if(temp>=35.0 && temp<=60.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Personal K is invalid (35<=K<=60)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrPersonK.SetFocus();
	 UpdateData(FALSE);
}

void PersonalACD::OnKillfocusEdPersonalPoref() 
{
	// TODO: Add your control notification handler code here
/*	 UpdateData();
	 double temp=atof(m_szPORef);
	 if(temp>=-3.3 && temp<=8.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="METHOD0 SF is invalid";
	 MessageBeep(MB_ICONQUESTION);
	 UpdateData(FALSE);*/
}
