//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_PERSONALACD_H__B870A8E1_5690_11D8_9309_D912D337F84B__INCLUDED_)
#define AFX_PERSONALACD_H__B870A8E1_5690_11D8_9309_D912D337F84B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PersonalACD.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// PersonalACD dialog

class PersonalACD : public CDialog
{
// Construction
public:
	PersonalACD(CWnd* pParent = NULL);   // standard constructor
	CWnd* m_pw;
    CString m_strAddionalRegistryOld;
	static	enum entypeRegistryNodes  m_enTypeRegNode;	
	static char* m_pszPatientRecFormat[];
	static char* m_pszDoctorRecFormat[];
	static char* m_pszLensTypeRecFormat[];
	static char* m_pszFullPatientRecFormat[];
	static char* m_pszFullDoctorRecFormat[];
	static char* m_pszFullLensTypeRecFormat[];
	static char* m_pszEditNewLensTypeRecFormat[];
	static struct sttypeRegistryNodes m_arListReg[];
	CString m_szDoctorId;
	CString m_szDFirstName;
	CString m_szDLastName;
    CMSFlexGrid* m_pDLensGrid;
	int m_nSelectedPersonalLens;
	double	m_dPersonAl;
	double	m_dPersonIOL;
	double	m_dPersonK;
	double	m_dPORef;
    double	m_dPersACD;
	double  m_dPersSF;
	double  m_dPersA_Const;
	double m_pfAverages[3];
	CString m_szMarkSel;
	HBRUSH   m_hbrDialBrush;
	COLORREF m_clrDialBrush;
	COLORREF m_clrDialBack;
	COLORREF m_clrDialFront;
	HBRUSH   m_hbrButtonsBrush;
    COLORREF m_clrButtonsBrush; 
	COLORREF m_clrButtonsBack;
	COLORREF m_clrButtonsFront;
	HBRUSH   m_hbrStaticBrush;
    COLORREF m_clrStaticBrush; 
	COLORREF m_clrStaticBack;
	COLORREF m_clrStaticFront;
	COLORREF m_clrMsgBoxesBrush; 
	HBRUSH   m_hbrMsgBoxesBrush;
	COLORREF m_clrMsgBoxesBack;
	COLORREF m_clrMsgBoxesFront;
	COLORREF m_clrEditBoxesBrush; 
	HBRUSH   m_hbrEditBoxesBrush;
	COLORREF m_clrEditBoxesBack;
	COLORREF m_clrEditBoxesFront;
	COLORREF m_clrScrollBarsBrush; 
	HBRUSH   m_hbrScrollBarsBrush;
	COLORREF m_clrScrollBarsBack;
	COLORREF m_clrScrollBarsFront;
	COLORREF m_clrListBoxesBrush; 
	HBRUSH   m_hbrListBoxesBrush;
	COLORREF m_clrListBoxesBack;
	COLORREF m_clrListBoxesFront;
	///////// METHOD1Formulas
friend void PersAcdMETHOD1Formula(double P,double Rx,double A,double K,double* pACD,unsigned int* n);
friend void QMETHOD1Formula(double* ACD,double A,double K,double pACD);
friend void METHOD1IOLPowerFormula(double* P,double AL,double K,double ACD,double Rx);
friend void METHOD1RetrErrFormula(double P,double A,double K,double C,double *Rx);
friend void METHOD1AxialLengthFormula(double P,double* A,double K,double C,double R);
///////// METHOD0Formulas
//friend void METHOD0FormulaForwardIOLSol(double* I,double Ref,double AL,double K,double SF,double V=12);
friend void METHOD0FormulaForwardRefSol(double I,double* Ref,double AL,double K,double SF,double V=12);
friend void METHOD0FormulaReverseSFSol(double I,double ARef,double AL,double K,double* SF,double V=12);
//////// Srk_tFormulas
friend void Srk_tEmmetrAmetrFormulaIOL(double*IOL,double REFR,double AL,double K1D,double K2D,double IOLACD);
friend void Srk_tEmmetrAmetrFormulaREFR(double IOL,double* REFR,double AL,double K1D,double K2D,double IOLACD);
friend void Srk_tCalc(double KD,double AL,double IOLACD,double Rx);
friend void Srk_tCalc(double* PEmmetrpNew,double KD,double AL,double IOLACD,double Rx);
friend void Srk_tGetA_Const(double* pA_Const, double IOL, double AL,double Ref,double K);
///////////////////////////
// Dialog Data
	//{{AFX_DATA(PersonalACD)
	enum { IDD = IDD_PERSONAL };
	CEdit	m_edEOREF;
	CButton	m_BtCancel;
	CButton	m_btOk;
	CEdit	m_cntrPersonK;
	CEdit	m_cntrPersonIOL;
	CEdit	m_cntrPersonAl;
	CButton	m_cntrPersonClear;
	CButton	m_cntrPersonCalc;
	CButton	m_cntrPersonApply;
	CMSFlexGrid	m_gridPersonalDoctorName;
	CMSFlexGrid	m_gridPersonalSelLens;
	CMSFlexGrid	m_gridPersonalCalculation;
	CMSFlexGrid	m_gridPersonalAverage;
	CString	m_szPersonAl;
	CString	m_szPersonIOL;
	CString	m_szPersonK;
	CString	m_szPORef;
	CString	m_strValidMessage;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PersonalACD)
	public:
	virtual BOOL Create(CWnd* pParentWnd);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(PersonalACD)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnBuPersonalApply();
	afx_msg void OnBuPersonalCalc();
	afx_msg void OnBuPersonalClear();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnChangeEdAl();
	afx_msg void OnChangeEdPersonalIol();
	afx_msg void OnChangeEdPersonalK();
	afx_msg void OnChangeEdPersonalPoref();
	virtual void OnCancel();
	afx_msg void OnKillfocusEdAl();
	afx_msg void OnKillfocusIol();
	afx_msg void OnKillfocusK();
	afx_msg void OnKillfocusEdPersonalPoref();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PERSONALACD_H__B870A8E1_5690_11D8_9309_D912D337F84B__INCLUDED_)
