// Editdoctor.cpp : implementation file
//

#include "stdafx.h"
//#include "ytvultrasoundmedscan0.h"
#include "Editdoctor.h"
#include "PersonalACD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Editdoctor dialog
entypeRegistryNodes Editdoctor::m_enTypeRegNode=encFullLensTypeRec;
char* Editdoctor::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* Editdoctor::m_pszLensTypeRecFormat[]={"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* Editdoctor::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* Editdoctor::m_pszDoctorRecFormat[]=     {"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* Editdoctor::m_pszFullDoctorRecFormat[]= {"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* Editdoctor::m_pszFullLensTypeRecFormat[]={"LensMfg","LensName", "MfgA_Const", "pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* Editdoctor::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
struct sttypeRegistryNodes Editdoctor::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL}

};
char Editdoctor::m_szPersSel[]="PERS";
char Editdoctor::m_szSel[]="SEL";
Editdoctor::Editdoctor(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	//{{AFX_DATA_INIT(Editdoctor)
	m_szDOfficeName = _T("");
	m_szDAddress = _T("");
	m_szDoctorId = _T("");
	m_szDFirstName = _T("");
	m_szDLastName = _T("");
	m_szNote = _T("");
	//}}AFX_DATA_INIT
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,255,255); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(255,255,255);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,255); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,255);
	m_clrEditBoxesFront=RGB(0,0,0);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
	m_nLastSel=0;
	m_pGridSelected=m_pGrid=NULL;
}


void Editdoctor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Editdoctor)
	DDX_Control(pDX, IDC_YTVEDIT5, m_edLName);
	DDX_Control(pDX, IDC_YTVEDIT4, m_edName);
	DDX_Control(pDX, IDC_YTVEDIT3, m_edId);
	DDX_Control(pDX, IDC_YTVEDIT2, m_Ad);
	DDX_Control(pDX, IDC_DE_NOTE, m_edNote);
	DDX_Control(pDX, IDC_YTVEDIT1, m_OFN);
	DDX_Control(pDX, IDC_LENS_SEL_PERSONAL, m_gridLensSelPersonal);
	DDX_Control(pDX, IDC_LENS_TABLE, m_gridLensTable);
	DDX_Text(pDX, IDC_YTVEDIT1, m_szDOfficeName);
	DDX_Text(pDX, IDC_YTVEDIT2, m_szDAddress);
	DDX_Text(pDX, IDC_YTVEDIT3, m_szDoctorId);
	DDX_Text(pDX, IDC_YTVEDIT4, m_szDFirstName);
	DDX_Text(pDX, IDC_YTVEDIT5, m_szDLastName);
	DDX_Text(pDX, IDC_DE_NOTE, m_szNote);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Editdoctor, CDialog)
	//{{AFX_MSG_MAP(Editdoctor)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_PERSONAL_VALUES, OnPERSONAl)
	ON_BN_CLICKED(IDC_DELETE_SELECTLENS, OnDeleteSelectedLens)
	ON_BN_CLICKED(IDC__OK, OnSave)
	ON_BN_CLICKED(IDC__CANCEL, OnNoChange)
	ON_WM_CREATE()
	ON_WM_SHOWWINDOW()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Editdoctor message handlers
void Editdoctor::OnOK()
{
	if(::GetFocus() != ::GetDlgItem (m_hWnd, ID__OK))
	{
	    NextDlgCtrl(); // Tab to next edit box	
		return;
    }
   OnSave();
}
void Editdoctor::OnCancel()
{
  OnNoChange(); 
}
HBRUSH Editdoctor::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	// TODO: Change any attributes of the DC here
		switch(nCtlColor)
	{
		default:
               hbr=CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
			return hbr;
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
        case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	hbr=CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		return hbr;
	// TODO: Return a different brush if the default is not desired
	
}
int Editdoctor::FindRecord(const char* RecordId, DWORD column)
{
   if(!m_pGrid)
	   return -1;
   int i=m_pGrid->GetRows(),j,res;
   CString Temp;
   if(i==0)
	   return -2;
   for(j=0;j<i;j++)
   {
      Temp=m_pGrid->GetTextMatrix(j,column); 
	  res=strcmp(Temp,RecordId);
	  if(res==0)
		  return j;
   }
   return -1;

}
int Editdoctor::FindLastRecord(DWORD column)
{
   if(!m_pGrid)
	   return -1;
   int i=m_pGrid->GetRows(),j;
   CString Temp;
   if(i==0)
	   return -2;
   for(j=0;j<i;j++)
   {
      Temp=m_pGrid->GetTextMatrix(j,column); 
	  if(Temp.IsEmpty())
		  return j;
   }
   return -1;
}
int Editdoctor::RefReadRegistryDB()
{
  int numbselected=0,numbchar,nr,nc,i,j,k,l,res,s;
  char* pch,*pchtemp;
  if(m_pGridSelected==NULL || m_pGrid==NULL)
	  return numbselected;
  if(m_arListReg[encFullDoctorTypeRec].Data==NULL)
	  return 0;
  m_enTypeRegNode=encFullDoctorTypeRec;
  YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);  
  CString  Subsection,Section=m_arListReg[encFullDoctorTypeRec].Data[0],Temp,TempS;
  Section+='\\';
  Section+=m_arListReg[encLensTypeRec].Node; //lenses  
  numbchar=YtvGetProfileSection(Section,NULL,0,1);
  if(numbchar==0)
		return numbselected;
  pch=new char[numbchar+1];
  numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
  if(numbchar==0)
		return numbselected;
  pchtemp=pch;
  nr=m_pGrid->GetRows();
  nc=m_pGrid->GetCols();
  Section+='\\';
  int ColsS=m_pGridSelected->GetCols();
  int RowsS=m_pGridSelected->GetRows();
  for(i=1;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
  {
	   Temp=pchtemp;
	   s=Temp.Find('=');
	   if(s>=0)
	      Temp=Temp.Left(s);
	   for(j=1;j<nr;j++)
       {
         if(Temp==m_pGrid->GetTextMatrix(j,1))
         {
			 m_nLastSel++;
			 m_pGrid->SetTextMatrix(j,0,m_szSel);
			 numbselected++;
			 if(RowsS<=numbselected)
				 break;
             Subsection=Section+Temp;
			
             TempS=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[0],"",1); 
             if(TempS==Temp)
             {   
                 m_pGridSelected->SetTextMatrix(numbselected,0,m_szPersSel);
                 m_pGridSelected->SetTextMatrix(numbselected,1,Temp);
				 
                 for(l=1;m_arListReg[encFullLensTypeRec].Format[l]!=NULL;)
                 {
                    Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[l],"",1); 
                    l++;
					if(ColsS>l)
					   m_pGridSelected->SetTextMatrix(numbselected,l,Temp);
                 }
             }
			 else
             {
               int Cols=m_pGridSelected->GetCols()-1;
			   for(l=1;l<nc;l++)
			   {
                Temp=m_pGrid->GetTextMatrix(j,l);
				for(k=0;m_arListReg[encFullLensTypeRec].Format[k]!=NULL;k++)
				{
					res=strcmp(m_arListReg[encFullLensTypeRec].Format[k],m_arListReg[encLensTypeRec].Format[l-1]);
					if(res==0)
					{
                      if(k<Cols) 
                          m_pGridSelected->SetTextMatrix(numbselected,k+1,Temp);
                      break;
					}
                }
			   }   
			 }  
			 break;
         }
       }
      
  }
  m_pGridSelected->SetRow(0);
  m_pGridSelected->SetRowSel(0);
  m_pGrid->SetRow(0);
  m_pGrid->SetRowSel(0);
  delete []pch;
  return numbselected;
}
int Editdoctor::RefWriteRegistryDB()
{
  if(!m_pGrid || !m_pGridSelected)
	   return 0; 
  int numbselected=0,i,j,nc,nr;
  BOOL b;
  if(m_arListReg[encFullDoctorTypeRec].Data==NULL)
	  return numbselected;
  m_enTypeRegNode=encFullDoctorTypeRec;
  YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
  CString Section=m_arListReg[encFullDoctorTypeRec].Data[0];
  Section+='\\';
  Section+=m_arListReg[encLensTypeRec].Node;  
  b=YtvWriteProfileSection(Section,NULL,1);
  YtvCreateRelativeRegNode(Section,1);
  Section+='\\';
  nr=m_pGrid->GetRows();
  CString Temp,Temp0;
 // m_nLastSel=0;
  CString Subsection; 
  for(i=1;i<nr;i++)
  {
      Temp=m_pGrid->GetTextMatrix(i,0);
	  if(Temp!=m_szSel)
		  continue;	 
	  numbselected++;
      Temp=m_pGrid->GetTextMatrix(i,1);
	  Subsection=Section+Temp;//lensid
      YtvCreateRelativeRegNode(Subsection,1);	  
  }
  nr=m_pGridSelected->GetRows();
  nc=m_pGridSelected->GetCols();
  for(i=1;i<nr;i++)
  {
     // Temp=m_pGridSelected->GetTextMatrix(i,0);
	  //if(Temp!=m_szPersSel)
	  //	  continue;	 
      Temp=m_pGridSelected->GetTextMatrix(i,1);
	  if(Temp.IsEmpty())
		  continue;
      Temp0=m_pGridSelected->GetTextMatrix(i,4);
	  Temp0+=m_pGridSelected->GetTextMatrix(i,6);
	  Temp0+=m_pGridSelected->GetTextMatrix(i,8);
	  if(Temp0.IsEmpty())
		  continue;
	  Subsection=Section+Temp;//lensid
	  YtvCreateRelativeRegNode(Subsection,1);
	  for(j=1;j<nc;j++)
	  {
        Temp=m_pGridSelected->GetTextMatrix(i,j);	
	    YtvWriteProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[j-1],Temp,1);
 	  }
  }
  return numbselected;
}
BOOL Editdoctor::WriteRegistryDB()
{
	int j;
	UpdateData();
	CString Temp0,Temp1;
	char *pf;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return FALSE;  
    pf=m_arListReg[m_enTypeRegNode].Format[0];
	if(pf==NULL)
		return FALSE;
	UpdateData();
	m_arListReg[encFullDoctorTypeRec].Data[4]=m_szDOfficeName;
	m_arListReg[encFullDoctorTypeRec].Data[5]=m_szDAddress;
	m_arListReg[encFullDoctorTypeRec].Data[0]=m_szDoctorId;
	m_arListReg[encFullDoctorTypeRec].Data[1]=m_szDFirstName;
	m_arListReg[encFullDoctorTypeRec].Data[2]=m_szDLastName;
    m_arListReg[encFullDoctorTypeRec].Data[3]=m_szNote;

	for(j=0;j<6;j++)
    {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
		   Temp1=m_arListReg[m_enTypeRegNode].Data[j];
           YtvWriteProfileString(m_arListReg[m_enTypeRegNode].Data[0],pf,Temp1,1); 		 
    }   
   	return TRUE;
}

int Editdoctor::ReadRegistryDB()
{
	 if(!m_pGrid)
	   return 0; 
	int NumbRecords=0,i,j;
	CString Temp0,Temp1;
	char* pch,*pf,*pchtemp;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return NumbRecords;
    int numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,NULL,0);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,pch,numbchar+1);
	if(numbchar==0)
		return NumbRecords;
	pchtemp=pch;
	for(i=1;pchtemp[0];i++,pchtemp+=strlen(pchtemp)+1)
    {
       m_pGrid->SetTextMatrix(i,1,pchtemp);       
    }
    NumbRecords=i-1;
	delete []pch;
	int Cols=m_pGrid->GetCols()-1;
    for(i=1;i<=NumbRecords;i++)
    {
        Temp0=m_pGrid->GetTextMatrix(i,1);
		for(j=1;Cols;j++)
        {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
           Temp1=YtvGetProfileString(Temp0,pf,"",1);
           m_pGrid->SetTextMatrix(i,j+1,Temp1);
        }
    }
	return NumbRecords;
}
BOOL Editdoctor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here	
	m_pGrid=&m_gridLensTable;
	m_pGridSelected=&m_gridLensSelPersonal;
    m_gridLensSelPersonal.SetRows(6);
	m_gridLensSelPersonal.SetCols(9);
	m_gridLensSelPersonal.SetFixedCols(0);
	m_gridLensSelPersonal.SetTextMatrix(0, 0, "Sel");
	m_gridLensSelPersonal.SetTextMatrix(0, 1, "Lens Mfg");   
    m_gridLensSelPersonal.SetTextMatrix(0, 2, "Lens Name");
	m_gridLensSelPersonal.SetTextMatrix(0, 3, "Mfg A-Const");
	m_gridLensSelPersonal.SetTextMatrix(0, 4, "pA-Const");
	m_gridLensSelPersonal.SetTextMatrix(0, 5, "Mfg ACD");
	m_gridLensSelPersonal.SetTextMatrix(0, 6, "pACD");
	m_gridLensSelPersonal.SetTextMatrix(0, 7, "Mfg SF");
	m_gridLensSelPersonal.SetTextMatrix(0, 8, "pSF");
	m_gridLensSelPersonal.SetColWidth(0,450);
	m_gridLensSelPersonal.SetColWidth(1,1000);
	m_gridLensSelPersonal.SetColWidth(2,1000);
	m_gridLensSelPersonal.SetColWidth(3,1000);
	m_gridLensSelPersonal.SetColWidth(4,1000);
	m_gridLensSelPersonal.SetColWidth(5,1000);	
	m_gridLensSelPersonal.SetColWidth(6,1000);
	m_gridLensSelPersonal.SetColWidth(7,1000);	
	m_gridLensSelPersonal.SetColWidth(8,1002);	
	///////////////////////////////////////////
    m_gridLensTable.SetRows(1000);
	m_gridLensTable.SetCols(6);
	m_gridLensTable.SetFixedCols(0);
	m_gridLensTable.SetTextMatrix(0, 0, "Sel");
	m_gridLensTable.SetTextMatrix(0, 1, "Lens Mfg");   
    m_gridLensTable.SetTextMatrix(0, 2, "Lens Name");
	m_gridLensTable.SetTextMatrix(0, 3, "Mfg A-Const");
	m_gridLensTable.SetTextMatrix(0, 4, "Mfg ACD");
	m_gridLensTable.SetTextMatrix(0, 5, "Mfg SF");
	m_gridLensTable.SetColWidth(0,450);
	m_gridLensTable.SetColWidth(1,1000);
	m_gridLensTable.SetColWidth(2,1000);
	m_gridLensTable.SetColWidth(3,1000);
	m_gridLensTable.SetColWidth(4,1000);
	m_gridLensTable.SetColWidth(5,1000);	
    for(int i=0; i<MaxNumbFieldsInDbLensStyleRec;i++)
            m_pszDbLensStyleRec[i]="";	
    m_enTypeRegNode=encFullDoctorTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
    m_arListReg[m_enTypeRegNode].Data=m_pszDbDoctorRec; 
    m_arListReg[m_enTypeRegNode].Data[0]=m_szDoctorId;
	m_szNote=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[3],"",1);
	m_szDOfficeName=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[4],"",1);
	m_szDAddress=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[5],"",1);
	m_enTypeRegNode=encFullLensTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	m_arListReg[encLensTypeRec].Data=m_pszDbLensStyleRec;   
    m_enTypeRegNode=encLensTypeRec;
	if(m_szDoctorId.IsEmpty())
		SetWindowText("New Doctor");
	ReadRegistryDB();
	RefReadRegistryDB();
	UpdateData(FALSE);
	//ShowWindow(SW_SHOWMAXIMIZED);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Editdoctor::OnPERSONAl() 
{
	// TODO: Add your control notification handler code here
    PersonalACD* dlg=new PersonalACD;
	UpdateData(TRUE);
	dlg->m_szDFirstName=m_szDFirstName;
	dlg->m_szDLastName=m_szDLastName;
	dlg->m_szDoctorId=m_szDoctorId;
	dlg->m_pDLensGrid=m_pGridSelected;
	dlg->m_szMarkSel=m_szPersSel;
    if(!dlg->Create(this))
	{
		UpdateData(FALSE);
		delete dlg;
		return;
    }
	//delete dlg;
	//UpdateData(FALSE);	
}
BEGIN_EVENTSINK_MAP(Editdoctor, CDialog)
    //{{AFX_EVENTSINK_MAP(Editdoctor)
	ON_EVENT(Editdoctor, IDC_LENS_TABLE, 69 /* SelChange */, OnSelChangeLensTable, VTS_NONE)
	ON_EVENT(Editdoctor, IDC_LENS_SEL_PERSONAL, 69 /* SelChange */, OnSelChangeLensSelPersonal, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void Editdoctor::OnSelChangeLensTable() 
{
	// TODO: Add your control notification handler code here
	if(!m_pGrid || !m_pGridSelected)
	   return ; 
	UpdateData();
	CString Temp,Temp0;
	int res;

    int row=m_pGrid->GetRowSel(),nc,k,l,nr;
	nc=m_pGrid->GetCols();
	if(row<1)
       return;
	Temp=m_pGrid->GetTextMatrix(row,1);
	if(Temp.IsEmpty())
		return;
    Temp=m_pGrid->GetTextMatrix(row,0);	
		if(Temp==m_szSel)
        {
			m_pGrid->SetTextMatrix(row,0,"");
            nr=m_pGridSelected->GetRows();
			Temp=m_pGrid->GetTextMatrix(row,1);
			for(k=1;k<nr;k++)
            {
               Temp0=m_pGridSelected->GetTextMatrix(k,1);
               if(Temp0.IsEmpty())
				   break;
			   if(Temp==Temp0)
               {  
				  m_pGridSelected->SetRow(k);
				  m_pGridSelected->SetCol(0);
                  //m_pGridSelected->SetColSel(m_pGridSelected->GetCols()-1);
                  OnDeleteSelectedLens();
				  return;
			   }
			}
          m_pGrid->SetRow(0);
          m_pGrid->SetRowSel(0);
		  m_pGridSelected->SetRow(0);
		  m_pGridSelected->SetRowSel(0);
           return;
        }
		else
        {			 
			
			 if(m_nLastSel<5)
             {
               m_pGrid->SetTextMatrix(row,0,m_szSel);
			   nc=m_pGrid->GetCols();
			   for(k=1;k<nc;k++)
			   {
                Temp=m_pGrid->GetTextMatrix(row,k);
				for(l=0;m_arListReg[encFullLensTypeRec].Format[l]!=NULL;l++)
				{
					res=strcmp(m_arListReg[encFullLensTypeRec].Format[l],m_arListReg[encLensTypeRec].Format[k-1]);
					if(res==0)
					{
						m_pGridSelected->SetTextMatrix(m_nLastSel+1,l+1,Temp);
                        break;
					}
                }
			   }			 
			   m_pGridSelected->SetTextMatrix(m_nLastSel,0,"");
			   m_nLastSel++;
             }

        }
		m_pGrid->SetRow(0);
        m_pGrid->SetRowSel(0);
		m_pGridSelected->SetRow(0);
		m_pGridSelected->SetRowSel(0);
    
}

void Editdoctor::OnSelChangeLensSelPersonal() 
{
	// TODO: Add your control notification handler code here
	 if(!m_pGridSelected)
	   return; 
		UpdateData();
	CString Temp;
    int row=m_pGridSelected->GetRowSel(),k,nr;
	if(row<1)
       return;	
	Temp=m_pGridSelected->GetTextMatrix(row,1);
	if(Temp.IsEmpty())
		return;
	Temp=m_pGridSelected->GetTextMatrix(row,0);
		if(Temp==m_szPersSel)
        {
			m_pGridSelected->SetTextMatrix(row,0,"");            
            return;
        }	    
		nr=m_pGridSelected->GetRows();
        for(k=1;k<nr;k++)
		{
			Temp=m_pGridSelected->GetTextMatrix(k,0);
			if(Temp==m_szPersSel)
			{
			  m_pGridSelected->SetTextMatrix(k,0,"");            
              break;
			}	    
        }
		m_pGridSelected->SetTextMatrix(row,0,m_szPersSel);
		m_pGridSelected->SetRow(0);	
		m_pGridSelected->SetRowSel(0);		
      
}

void Editdoctor::OnDeleteSelectedLens() 
{
	// TODO: Add your control notification handler code here
     if(!m_pGrid || !m_pGridSelected)
	   return ; 
	UpdateData();
	CString Temp;
	CString Mfg;
	int nr,nc,i,j;
    int row=m_pGridSelected->GetRowSel();	
	if(row>0)
    {
        Temp=m_pGridSelected->GetTextMatrix(row,1);
		if(Temp.IsEmpty())
			return;
        nr=m_pGridSelected->GetRows();  
		nc=m_pGridSelected->GetCols();
		Mfg=m_pGridSelected->GetTextMatrix(row,1);
        if(row+1==nr || nr==1)
        {		   	
            for(j=0; j<nc;j++)
			   m_pGridSelected->SetTextMatrix(row,j,"");
			return;
        }
		nr--;
		for(i=row; i<nr;i++)
        {
            for(j=0; j<nc;j++)
			{
				Temp=m_pGridSelected->GetTextMatrix(i+1,j);
                m_pGridSelected->SetTextMatrix(i,j,Temp); 
            }			
        }
		for(j=0; j<nc;j++)
			   m_pGridSelected->SetTextMatrix(nr,j,"");
		if(m_nLastSel>0)
		       m_nLastSel--;
	}
    nr=m_pGrid->GetRows();
	for(j=1; j<nr;j++)
	{
				Temp=m_pGrid->GetTextMatrix(j,1);
				if(Temp==Mfg)
                {
					m_pGrid->SetTextMatrix(j,0,""); 
                    break;
                }
    }	
}

void Editdoctor::OnSave() 
{
	// TODO: Add your control notification handler code here
/*	if(::GetFocus() != ::GetDlgItem (m_hWnd, ID__OK))
	{
	    NextDlgCtrl(); // Tab to next edit box	
		return;
    }*/
	m_enTypeRegNode=encFullDoctorTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	WriteRegistryDB();
	RefWriteRegistryDB();
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
	//ShowWindow(SW_RESTORE);
    m_pdb->SetForegroundWindow();
	DestroyWindow();
	delete this;
	//CDialog::OnOK();
}

BOOL Editdoctor::Create(CWnd* pParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pdb=(DataBasePage*)pParentWnd;
	return CDialog::Create(IDD, pParentWnd);
}

void Editdoctor::OnNoChange() 
{
	// TODO: Add extra cleanup here
    YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
	//ShowWindow(SW_RESTORE);
	DestroyWindow();
	delete this;
	//CDialog::OnCancel();
}

int Editdoctor::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	return 0;
}

void Editdoctor::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	//CDialog::OnShowWindow(bShow, nStatus);
	ShowWindow(SW_MAXIMIZE);
	// TODO: Add your message handler code here
	
}


void Editdoctor::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);
}
