//{{AFX_INCLUDES()
#include "msflexgrid.h"
//#include "ytvgraphctrl.h"
//}}AFX_INCLUDES
#if !defined(AFX_PRINTPAGE_H__213CBB12_002D_4401_BAB4_E88B28E19B90__INCLUDED_)
#define AFX_PRINTPAGE_H__213CBB12_002D_4401_BAB4_E88B28E19B90__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PrintPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// PrintPage dialog
#define MaxNumbFieldsInDbPatientRec 100
#define MaxNumbFieldsInDbDoctorRec 40
#define MaxNumbFieldsInDbLensStyleRec 100
class CCalculatorPage;
class MeasurementPage;
class PrintPage : public CPropertyPage
{
	DECLARE_DYNCREATE(PrintPage)

// Construction
public:
	PrintPage();
	~PrintPage();
	void DisplayGraph();
	BOOL PlayScan(const char* SesDate,const char* ScanNum);
	CString m_strAddionalRegistryOld;
    //CPrintInfo m_struPrintInfo;
		/////////////// auxFormulas
friend double SfFromAConst(double A_C);
friend double SfFromAcd(double ACD);
friend double AcdFromSF(double SF);
friend double AConstFromSF(double SF);
friend double SrkACDFromAConst(double A_Const);
///////////////////////////////////////
	struct ThreshHolds
    {
      unsigned Pics[4];
    }m_curThr;
	unsigned m_NumbPics[4];
	void DrawMarks(unsigned int MakeSound);
	int *m_npDataBuf;
	int m_nMemorySize;
	CString m_strScanNumber;
	CString m_strDate;
	int m_nCurrentScanGroup;
	CString m_strGroupScan;
	CFont m_font;
	CFont* m_pfont;
	TEXTMETRIC m_tme;
	int m_nFontHeight;
	//TEXTMETRIC m_tme;
	LOGFONT m_logfont;
///////////////////////////////////////////////////////
	CString m_pszDbDoctorRec[MaxNumbFieldsInDbDoctorRec];
    static	enum entypeRegistryNodes  m_enTypeRegNode;
    static char* m_pszPatientRecFormat[];
	static struct sttypeRegistryNodes m_arListReg[];
////////////
static char* m_pszDoctorRecFormat[];//={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
static char* m_pszLensTypeRecFormat[];//={"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
static char* m_pszFullPatientRecFormat[];//={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
static char* m_pszFullDoctorRecFormat[];//={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
static char* m_pszFullLensTypeRecFormat[];//={"LensMfg","LensName", "MfgA_Const", "pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
static char* m_pszEditNewLensTypeRecFormat[];//
static char* m_pszMeasureHistoryTypeRecFormat[];//={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt"};
static char* m_pszCalculatorTypeRecFormat[];
// Dialog Data
	//{{AFX_DATA(PrintPage)
	enum { IDD = IDD_PRINT };
	int		m_nFormula;
	CMSFlexGrid	m_gridPatientPrint;
	BOOL	m_bPrintCalculation;
	BOOL	m_bPrintScan;
	BOOL	m_bSetupPrinter;
	BOOL	m_bPreview;
	BOOL	m_bStartPrint;
	CYtvGraphCtrl	m_imGraph;
	//}}AFX_DATA
    HBITMAP m_hbm;
	/////////////////////////////////
	int ReadRegDB();
	int m_nStartPrint;
	CString	m_szDoctorId;
	CString	m_szPatient_Id;
	CString	m_szFirstname;
	CString	m_szLastname;
	CString	m_szP_Address;
	CString	m_szP_city;
	CString	m_szP_zip;
	CString	m_szK_value_l;
	CString	m_szK_value_r;
	CString	m_szK1_value_l;
	CString	m_szK1_value_r;
	CString	m_szK2_value_l;
	CString	m_szK2_value_r;
	CString	m_szP_age;
	CString	m_szDob_mm;
	CString	m_szDob_yy;
	CString	m_szDob_dd;
	CString	m_szNote;
	CString	m_szDoctorName;
	int		m_nGender;
	CString	m_szP_phone;
	CString	m_szP_state;
	CString	m_szNoteD;//=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[3],"",1);
	CString	m_szDOfficeName;//=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[4],"",1);
	CString	m_szDAddress;
	CString	m_strMfg;
	double m_dAL;
	double m_dAconst;
    double m_dAcd;
    double m_dSF;
	double m_dRx;
	int DoctorRefReadRegistryDB();   
	//int DoctorReadRegistryDB(); 
	void OnDraw(CDC* pDC,CCalculatorPage* cp,MeasurementPage* mp,CPrintInfo* pInfo); 
	int m_NumbRecords;
	int m_nLastSel;
	///////////////////////////////////////////////////
// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(PrintPage)
	public:
	virtual BOOL OnSetActive();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
HBRUSH   m_hbrDialBrush;
	COLORREF m_clrDialBrush;
	COLORREF m_clrDialBack;
	COLORREF m_clrDialFront;
	HBRUSH   m_hbrButtonsBrush;
    COLORREF m_clrButtonsBrush; 
	COLORREF m_clrButtonsBack;
	COLORREF m_clrButtonsFront;
	HBRUSH   m_hbrStaticBrush;
    COLORREF m_clrStaticBrush; 
	COLORREF m_clrStaticBack;
	COLORREF m_clrStaticFront;
	COLORREF m_clrMsgBoxesBrush; 
	HBRUSH   m_hbrMsgBoxesBrush;
	COLORREF m_clrMsgBoxesBack;
	COLORREF m_clrMsgBoxesFront;
	COLORREF m_clrEditBoxesBrush; 
	HBRUSH   m_hbrEditBoxesBrush;
	COLORREF m_clrEditBoxesBack;
	COLORREF m_clrEditBoxesFront;
	COLORREF m_clrScrollBarsBrush; 
	HBRUSH   m_hbrScrollBarsBrush;
	COLORREF m_clrScrollBarsBack;
	COLORREF m_clrScrollBarsFront;
	COLORREF m_clrListBoxesBrush; 
	HBRUSH   m_hbrListBoxesBrush;
	COLORREF m_clrListBoxesBack;
	COLORREF m_clrListBoxesFront;
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(PrintPage)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	virtual BOOL OnInitDialog();
	afx_msg void OnStartPrint();
	afx_msg void OnPreview();
	afx_msg void OnPaint();
	afx_msg void OnFilePrintPreview();
	afx_msg void OnFilePrintSetup();
	afx_msg void OnPrintersetup();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PRINTPAGE_H__213CBB12_002D_4401_BAB4_E88B28E19B90__INCLUDED_)
